import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "Turbine.Utils";
import "KragenPlugs.KragenBars";

CaptBars = class( );

function CaptBars:Constructor()

 	-- inialize the setupWindow
	self.setup = SetupWindow();
	self.bannerSetup = BannerSetup();
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		self.player = Turbine.Gameplay.LocalPlayer.GetInstance();
	else
		self.player = Turbine.Gameplay.LocalPlayer();
	end
	local curlevel = self.player:GetLevel();

	-- class settings arnt saved then load the default settings
	if (not settings.class) then
	    settings.class = "Captain";
	    self:DefaultSettings();
	    self:ShowSetup();
	else
		self.settings = settings.classinfo;
	end

	-- Build skills and level tables
	
	self.skills = { };
	self.skills["RallyingCry"]=		{["Level"]=2,["Hex"]="0x70002F4F"};
	self.skills["WarCry"]=			{["Level"]=4,["Hex"]="0x70002F58"};
	self.skills["OnGuard"]=			{["Level"]=6,["Hex"]="0x70003E53"};
	self.skills["RoutingCry"]=		{["Level"]=8,["Hex"]="0x70002F61"};
	self.skills["HeraldofWar"]=		{["Level"]=10,["Hex"]="0x70002F7A"};
	self.skills["MotivatingSpeech"]={["Level"]=16,["Hex"]="0x70003E52"};
	self.skills["HeraldofHope"]=	{["Level"]=24,["Hex"]="0x70002FAF"};
	self.skills["RelentlessAttack"]={["Level"]=28,["Hex"]="0x70003E55"};
	self.skills["CryofVengence"]=	{["Level"]=32,["Hex"]="0x70003E57"};
	self.skills["HeraldofVictory"]=	{["Level"]=34,["Hex"]="0x70002F1A"};
	self.skills["Focus"]=			{["Level"]=38,["Hex"]="0x70003E59"};
	self.skills["IDOME"]=			{["Level"]=45,["Hex"]="0x7000130D"};
	self.skills["Archer"]=			{["Level"]=56,["Hex"]="0x7000FC78"};
	self.skills["ShadowsLament"]=	{["Level"]=60,["Hex"]="0x7000FF8B"};
    
    self.window = { };

    -- ENEMY DEFEAT WINDOW
    self.window[1] = Window("DEFEAT", 4, 1, -2, 0, self.settings.defeat);

		-- Defeat
		self.window[1]:AddBar(1, 1, 1, 0, 0, false, false);
		self.window[1].bar[1]:AddQuickSlot(1, 1, 1, self.skills["RallyingCry"].Hex); -- Rallying Cry
		
		self.window[1]:AddBar(2, 1, 1, 1, 0, false, false);
		self.window[1].bar[2]:AddQuickSlot(1, 1, 1, self.skills["WarCry"].Hex); -- War Cry
		
		self.window[1]:AddBar(3, 1, 1, 2, 0, false, false);
		self.window[1].bar[3]:AddQuickSlot(1, 1, 1, self.skills["RoutingCry"].Hex); -- Routing Cry
		
		self.window[1]:AddBar(4, 1, 1, 3, 0, false, false);
		self.window[1].bar[4]:AddQuickSlot(1, 1, 1, self.skills["ShadowsLament"].Hex); -- Shadow's Lament
		
	-- Buffs
	self.window[2] = Window("BUFFS", 3, 1, -1.5, 1, self.settings.buffs);
	
	    -- IDOME
	    self.window[2]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[2].bar[1]:AddQuickSlot(1, 1, 1, self.skills["IDOME"].Hex); -- IDOME
		if (curlevel < self.skills["IDOME"].Level) then
			self.window[2].bar[1]:SetVisible(0);
		else
			self.window[2].bar[1]:SetVisible(self.settings.buffs.idome);
		end
		
		-- MOTIVATING
	    self.window[2]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[2].bar[2]:AddQuickSlot(1, 1, 1, self.skills["MotivatingSpeech"].Hex); -- Motivating Speech
		if (curlevel < self.skills["MotivatingSpeech"].Level) then
			self.window[2].bar[2]:SetVisible(0);
		else
			self.window[2].bar[2]:SetVisible(self.settings.buffs.motivating);
		end
		
		-- TACTICS
	    self.window[2]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[2].bar[3]:AddQuickSlot(1, 1, 1, "");
		self.window[2].bar[3].slot[1]:MultiShortcut(6, self.skills["OnGuard"].Hex); -- OnGuard
		self.window[2].bar[3].slot[1]:MultiShortcut(6, self.skills["RelentlessAttack"].Hex); -- RelentlessAttack
		self.window[2].bar[3].slot[1]:MultiShortcut(6, self.skills["Focus"].Hex); -- Focus
		self.window[2].bar[3].slot[1]:SetScroll(true);
        self.window[2].bar[3].slot[1]:SetMulti(1);
		if (curlevel >= self.skills["Focus"].Level) then
			self.window[2].bar[3].slot[1]:ChangeTotal(3);
		elseif (curlevel >= self.skills["RelentlessAttack"].Level) then
			self.window[2].bar[3].slot[1]:ChangeTotal(2);
		elseif (curlevel >= self.skills["OnGuard"].Level) then
			self.window[2].bar[3].slot[1]:ChangeTotal(1);
		else
			self.window[2].bar[3].slot[1]:ChangeTotal(0);
			self.window[2].bar[3]:SetVisible(0);
		end        

	-- VENGENCE
	self.window[3] = Window("REZ", 1, 1, 3, 0, self.settings.vengence);
	
	     -- Vengence
	    self.window[3]:AddBar(1, 1, 1, 0, 0, false, false);
		self.window[3].bar[1]:AddQuickSlot(1, 1, 1, self.skills["CryofVengence"].Hex); -- Cry of Vengence
		if (curlevel < self.skills["CryofVengence"].Level) then
			self.window[3].bar[1]:SetVisible(0);
		else
			self.window[3].bar[1]:SetVisible(self.settings.vengence);
		end	
	
	-- HERALDS
	self.window[4] = Window("BANNER", 1, 1, -3, 1, self.settings.petban);

	     -- Heralds
	    self.window[4]:AddBar(1, 1, 1, 0, 0, self.settings.heralds, false);
		self.window[4].bar[1]:AddQuickSlot(1, 1, 1, "");
		self.window[4].bar[1].slot[1]:MultiShortcut(6, self.skills["HeraldofWar"].Hex); -- WAR
		self.window[4].bar[1].slot[1]:MultiShortcut(6, self.skills["HeraldofHope"].Hex); -- HOPE
		self.window[4].bar[1].slot[1]:MultiShortcut(6, self.skills["HeraldofVictory"].Hex); -- VICTORY
		self.window[4].bar[1].slot[1]:MultiShortcut(6, self.skills["Archer"].Hex); -- ARCHER
		self.window[4].bar[1].slot[1]:SetScroll(true);
        self.window[4].bar[1].slot[1]:SetMulti(self.settings.heralds.current);
		if (curlevel >= self.skills["Archer"].Level) then
			self.window[4].bar[1].slot[1]:ChangeTotal(4);
		elseif (curlevel >= self.skills["HeraldofVictory"].Level) then
			self.window[4].bar[1].slot[1]:ChangeTotal(3);
		elseif (curlevel >= self.skills["HeraldofHope"].Level) then
			self.window[4].bar[1].slot[1]:ChangeTotal(2);
		elseif (curlevel >= self.skills["HeraldofWar"].Level) then
			self.window[4].bar[1].slot[1]:ChangeTotal(1);
		else
			self.window[4].bar[1].slot[1]:ChangeTotal(0);
			self.window[4].bar[1]:SetVisible(0);
		end        


	     -- Banners
	    self.window[4]:AddBar(2, 1, 1, 0, 0, self.settings.banners, false);
		self.window[4].bar[2]:AddQuickSlot(1, 1, 1, "");
		self.window[4].bar[2].slot[1]:MultiShortcut(self.settings.banners.banner[1].Type, self.settings.banners.banner[1].Data); -- HOPE
		self.window[4].bar[2].slot[1]:MultiShortcut(self.settings.banners.banner[2].Type, self.settings.banners.banner[2].Data); -- VICTORY
		self.window[4].bar[2].slot[1]:MultiShortcut(self.settings.banners.banner[3].Type, self.settings.banners.banner[3].Data); -- WAR
		self.window[4].bar[2].slot[1]:SetScroll(true);
        self.window[4].bar[2].slot[1]:SetMulti(self.settings.banners.current);
        
        -- Armament
	    self.window[4]:AddBar(3, 1, 1, 0, 0, false, false);
		self.window[4].bar[3]:AddQuickSlot(1, 1, 1, "");
		self.window[4].bar[3].slot[1]:MultiShortcut(self.settings.banners.banner[4].Type, self.settings.banners.banner[4].Data); -- ARMAMENTS
        self.window[4].bar[3].slot[1]:SetMulti(1);
        
	if (self.settings.petban.current == 1) then
		self.window[4].bar[1]:SetVisible( true );
		self.window[4].bar[2]:SetVisible( false );
	else
	    self.window[4].bar[1]:SetVisible( false );
		self.window[4].bar[2]:SetVisible( true );
	end


	self.window[4].bar[1].slot[1].MouseClick = function(sender, args)
        if ( args.Button == Turbine.UI.MouseButton.Right ) then
	        self.window[4].bar[1]:SetVisible( false );
	        self.window[4].bar[2]:SetVisible( true );
	        self.window[4].bar[3]:SetVisible( false );
	        self.settings.petban.current = 2;
	    end
	end
	
	self.window[4].bar[2].slot[1].MouseClick = function(sender, args)
	    if ( args.Button == Turbine.UI.MouseButton.Right and self.settings.heralds.active) then
	    	if (self.settings.banners.banner[4].Type ~= 0) then
				self.window[4].bar[1]:SetVisible( false );
			    self.window[4].bar[2]:SetVisible( false );
			    self.window[4].bar[3]:SetVisible( true );
			    self.settings.petban.current = 3;
			else
				self.window[4].bar[1]:SetVisible( true );
	    		self.window[4].bar[2]:SetVisible( false );
	    		self.window[4].bar[3]:SetVisible( false );
				self.window[4].bar[1].slot[1]:SetMulti(self.settings.heralds.current);
			end
	    end

	end
	
	self.window[4].bar[3].slot[1].MouseClick = function(sender, args)
        if ( args.Button == Turbine.UI.MouseButton.Left ) then
   			self.window[4]:SetWantsUpdates( true );
		else
		    self.window[4].bar[1]:SetVisible( true );
	    	self.window[4].bar[2]:SetVisible( false );
	    	self.window[4].bar[3]:SetVisible( false );
			self.window[4].bar[1].slot[1]:SetMulti(self.settings.heralds.current);
			self.settings.petban.current = 1;
		end
	end
	
	self.window[4].Update = function (sender, args)
        self.window[4].bar[1]:SetVisible( true );
	    self.window[4].bar[2]:SetVisible( false );
	    self.window[4].bar[3]:SetVisible( false );
		self.window[4].bar[1].slot[1]:SetMulti(self.settings.heralds.current);
		self.settings.petban.current = 1;
		self.window[4]:SetWantsUpdates(false);
	end
	
	
	-- SET WINDOW OPACITY
	self.window[1]:SetOpacity(settings.opacity);
	self.window[2]:SetOpacity(settings.opacity);
	self.window[3]:SetOpacity(settings.opacity);
	self.window[4]:SetOpacity(settings.opacity);
	
	
	-- SET WINDOW VISIBILITY
	self.window[1]:SetVisible(self.settings.defeat.active);
	self.window[2]:SetVisible(self.settings.buffs.active);
	self.window[3]:SetVisible(self.settings.vengence.active);
	self.window[4]:SetVisible(self.settings.petban.active);
        

	-- Hook into the player to receive updates about player morale and
	-- power.
	local effects = self.player:GetEffects();

	effects.EffectAdded = function( sender, args )
		self:AddEffect( args.Index );
	end

	effects.EffectRemoved = function( sender, args )
		self:RemoveEffect( args.Effect );
	end
	
	self.player.InCombatChanged = function( sender, args )
      	if (self.player:IsInCombat() == false) then
			if (self.settings.heralds.active and self.settings.petban.current == 1) then
			    self.window[4].bar[1]:SetVisible( true );
                self.window[4].bar[2]:SetVisible( false );
			end
		elseif (self.player:IsInCombat() == true ) then
            if (self.settings.heralds.active) then
			    self.window[4].bar[1]:SetVisible( false );
				if (self.settings.banners.active) then
					self.window[4].bar[2]:SetVisible( true );
				end
			end
		end
	end
end


function CaptBars:AddEffect( effectIndex )
	local addedeffect = self.player:GetEffects():Get( effectIndex );
	local curlevel = self.player:GetLevel();

	-- Defeat Response
	if (addedeffect:GetName() == "Enemy Defeat Response") then
        self.window[1]:BarActive(1 , addedeffect:GetID(), true, true);
		if (curlevel >= self.skills["RallyingCry"].Level) then
			self.window[1].bar[1]:SetVisible(true);
		else
			self.window[1].bar[1]:SetVisible(false);
		end
		if (curlevel >= self.skills["WarCry"].Level) then
			self.window[1].bar[2]:SetVisible(true);
		else
			self.window[1].bar[2]:SetVisible(false);
		end
		if (curlevel >= self.skills["RoutingCry"].Level) then
			self.window[1].bar[3]:SetVisible(true);
		else
			self.window[1].bar[3]:SetVisible(false);
		end
		if (curlevel >= self.skills["ShadowsLament"].Level) then
			self.window[1].bar[4]:SetVisible(true);
		else
			self.window[1].bar[4]:SetVisible(false);
		end
		
    -- IDOME
	elseif (addedeffect:GetName() == "In Defence of Middle-Earth") then
  		if (curlevel >= self.skills["IDOME"].Level) then
			self.window[2]:BarActive(1 , addedeffect:GetID(), true, false);
			if (self.settings.buffs.timer and self.settings.buffs.idome) then
				self.window[2].bar[1]:StartTimer(addedeffect:GetDuration() * .80, true);
			end
		end

    -- Motivated
	elseif (addedeffect:GetName() == "Motivated") then
  		if (curlevel >= self.skills["MotivatingSpeech"].Level) then
			self.window[2]:BarActive(2 , addedeffect:GetID(), true, false);
			if (self.settings.buffs.timer and self.settings.buffs.motivating) then
				self.window[2].bar[2]:StartTimer(addedeffect:GetDuration() * .80, true);
			end
		end
		
    -- Vengence
	elseif (addedeffect:GetName() == "Fellow Defeat Response") then
  		if (curlevel >= self.skills["CryofVengence"].Level and self.settings.vengence.active) then
			self.window[3]:BarActive(1 , addedeffect:GetID(), true, true);
  		end
	
	elseif (addedeffect:GetName() == "Banner of Hope" or addedeffect:GetName() == "Banner of Victory" or addedeffect:GetName() == "Banner of War") then
	    if (self.settings.petban.active) then
			self.window[4]:BarActive(1, addedeffect:GetID(), true, true);
			self.window[4].bar[1]:SetHover( true );
			self.window[4]:BarActive(2, addedeffect:GetID(), true, true);
			self.window[4].bar[2]:SetHover( true );

			if (self.settings.petban.current == 1) then
				self.window[4].bar[1]:SetVisible( not self.player:IsInCombat() );
				self.window[4].bar[2]:SetVisible( false );
			else
				self.window[4].bar[1]:SetVisible( false );
				self.window[4].bar[2]:SetVisible( true );
			end
		end
		
    elseif (addedeffect:GetName() == "Relentless Attack" or addedeffect:GetName() == "On Guard" or addedeffect:GetName() == "Focus") then
	    if (self.settings.buffs.tactics) then
			self.window[2]:BarActive(3, addedeffect:GetID(), true, true);
			if (self.settings.buffs.tacticfade) then
				self.window[2].bar[3]:SetVisible( false );
				if (self.settings.buffs.timer) then
					self.window[2].bar[3]:StartTimer(addedeffect:GetDuration() * .80, true);
				end
			else
				self.window[2].bar[3]:SetHover( true );
			end
		end
	end
end

function CaptBars:RemoveEffect( effect )
	local curlevel = self.player:GetLevel();

	-- Defeat Response
	if (effect:GetName() == "Enemy Defeat Response") then
        self.window[1]:BarActive(1 , effect:GetID(), false, false);
		if (self.window[1].bar[1].effectID == 0) then
			self.window[1].bar[2]:SetVisible(false);
			self.window[1].bar[3]:SetVisible(false);
			self.window[1].bar[4]:SetVisible(false);
		end

	-- IDOME
    elseif (effect:GetName() == "In Defence of Middle-Earth") then
     	if (curlevel >= self.skills["IDOME"].Level and self.settings.buffs.idome) then
			self.window[2]:BarActive(1 , effect:GetID(), false, true);
		end

	-- Motivated
    elseif (effect:GetName() == "Motivated") then
        if (curlevel >= self.skills["MotivatingSpeech"].Level and self.settings.buffs.motivating) then
			self.window[2]:BarActive(2 , effect:GetID(), false, true);
		end

	-- Vengence
    elseif (effect:GetName() == "Fellow Defeat Response") then
     	self.window[3]:BarActive(1 , effect:GetID(), false, false);
     	
    elseif (effect:GetName() == "Banner of Hope" or effect:GetName() == "Banner of Victory" or effect:GetName() == "Banner of War") then
	    if (self.settings.petban.active) then
			self.window[4]:BarActive(1, effect:GetID(), false, true);
			if (self.window[4].bar[1].effectID == 0) then
				self.window[4].bar[1]:SetHover( false );
			end
			self.window[4]:BarActive(2, effect:GetID(), false, true);
			if (self.window[4].bar[2].effectID == 0) then
				self.window[4].bar[2]:SetHover( false );
			end
		
			if (self.settings.petban.current == 1) then
				self.window[4].bar[1]:SetVisible( not self.player:IsInCombat() );
				self.window[4].bar[2]:SetVisible( false );
			else
				self.window[4].bar[1]:SetVisible( false );
				self.window[4].bar[2]:SetVisible( true );
			end
		end
		
    elseif (effect:GetName() == "Relentless Attack" or effect:GetName() == "On Guard" or effect:GetName() == "Focus") then
	    if (self.settings.buffs.tactics) then
			self.window[2]:BarActive(3, effect:GetID(), false, true);
			if (self.window[2].bar[3].effectID == 0) then
				self.window[2].bar[3]:SetHover( false );
			end
		end
		
	end
end

function CaptBars:DefaultSettings()
	self.settings = { };

	self.settings.defeat = { };
	self.settings.defeat.active = true;
	self.settings.defeat.x = 0;
	self.settings.defeat.y = 0;
	
	self.settings.buffs = { };
	self.settings.buffs.active = true;
	self.settings.buffs.x = 0;
	self.settings.buffs.y = 0;
	self.settings.buffs.idome = true;
	self.settings.buffs.motivating = true;
	self.settings.buffs.tactics = true;
	self.settings.buffs.timer = true;
	self.settings.buffs.tacticfade = false;

	self.settings.vengence = { };
	self.settings.vengence.active = true;
	self.settings.vengence.x = 0;
	self.settings.vengence.y = 0;

    self.settings.petban = { };
	self.settings.petban.active = true;
	self.settings.petban.x = 0;
	self.settings.petban.y = 0;
	self.settings.petban.current = 1;

	self.settings.heralds = { };
	self.settings.heralds.active = true;
	self.settings.heralds.current = 1;
	
	self.settings.banners = { };
	self.settings.banners.active = true;
	self.settings.banners.current = 1;
	
	self.settings.banners.banner = { };
	self.settings.banners.banner[1] = { };
	self.settings.banners.banner[2] = { };
	self.settings.banners.banner[3] = { };
	self.settings.banners.banner[4] = { };
	self.settings.banners.banner[1].Type = 0;
	self.settings.banners.banner[1].Data = "";
	self.settings.banners.banner[2].Type = 0;
	self.settings.banners.banner[2].Data = "";
	self.settings.banners.banner[3].Type = 0;
	self.settings.banners.banner[3].Data = "";
	self.settings.banners.banner[4].Type = 0;
	self.settings.banners.banner[4].Data = "";
end

function CaptBars:SaveSettings()
	self.settings.defeat.x, self.settings.defeat.y = self.window[1]:GetPosition();
	self.settings.buffs.x, self.settings.buffs.y = self.window[2]:GetPosition();
	self.settings.vengence.x, self.settings.vengence.y = self.window[3]:GetPosition();
	self.settings.petban.x, self.settings.petban.y = self.window[4]:GetPosition();
	settings.classinfo = self.settings;
	SaveSettings();
end

function CaptBars:ShowSetup()
	self.setup:SetVisible(true);
	self.setup.slider1:SetValue(settings.opacity);
	
	self.setup.checkbox1:SetText("Defeat Response");
	self.setup.checkbox2:SetText("Buffs");
	self.setup.checkbox3:SetText("Cry of Vengence");
  	self.setup.checkbox4:SetText("Heralds/Banners");
   	self.setup.checkbox5:SetText("IDOME");
  	self.setup.checkbox6:SetText("Motivating Speech");
  	self.setup.checkbox7:SetText("Tactics");
  	self.setup.checkbox8:SetVisible(false);
    self.setup.checkbox9:SetText("Early Warning");
    self.setup.checkbox10:SetText("Tactic Disappear");
    self.setup.checkbox11:SetText("Heralds");
  	self.setup.checkbox1:SetChecked( self.settings.defeat.active );
  	self.setup.checkbox2:SetChecked( self.settings.buffs.active );
  	self.setup.checkbox3:SetChecked( self.settings.vengence.active );
  	self.setup.checkbox4:SetChecked( self.settings.petban.active );
  	self.setup.checkbox5:SetChecked( self.settings.buffs.idome );
  	self.setup.checkbox6:SetChecked( self.settings.buffs.motivating );
  	self.setup.checkbox7:SetChecked( self.settings.buffs.tactics );
  	self.setup.checkbox9:SetChecked( self.settings.buffs.timer );
   	self.setup.checkbox10:SetChecked( self.settings.buffs.tacticfade );
   	self.setup.checkbox11:SetChecked( self.settings.heralds.active );
    self.setup.psTitle:SetVisible( false );
    self.setup.ssTitle:SetVisible( false );
	self.setup:SetText("KB: Captain");
	
	self.bannerSetup:SetVisible( true );
	self.bannerSetup.qs[1]:SetShortcut(Turbine.UI.Lotro.Shortcut( self.settings.banners.banner[1].Type, self.settings.banners.banner[1].Data ));
	self.bannerSetup.qs[2]:SetShortcut(Turbine.UI.Lotro.Shortcut( self.settings.banners.banner[2].Type, self.settings.banners.banner[2].Data ));
	self.bannerSetup.qs[3]:SetShortcut(Turbine.UI.Lotro.Shortcut( self.settings.banners.banner[3].Type, self.settings.banners.banner[3].Data ));
	self.bannerSetup.qs[4]:SetShortcut(Turbine.UI.Lotro.Shortcut( self.settings.banners.banner[4].Type, self.settings.banners.banner[4].Data ));
end

function CaptBars:SetupClosing()
    self.settings.defeat.active = self.setup.checkbox1:GetChecked();
	self.settings.buffs.active = self.setup.checkbox2:GetChecked();
	self.settings.vengence.active = self.setup.checkbox3:GetChecked();
	self.settings.petban.active = self.setup.checkbox4:GetChecked();
	self.settings.buffs.idome = self.setup.checkbox5:GetChecked();
	self.settings.buffs.motivating = self.setup.checkbox6:GetChecked();
	self.settings.buffs.tactics = self.setup.checkbox7:GetChecked();
	self.settings.buffs.timer = self.setup.checkbox9:GetChecked();
	self.settings.buffs.tacticfade = self.setup.checkbox10:GetChecked();
	self.settings.heralds.active = self.setup.checkbox11:GetChecked();
	
	-- SET WINDOW OPACITY
	self.window[1]:SetOpacity(settings.opacity);
	self.window[2]:SetOpacity(settings.opacity);
	self.window[3]:SetOpacity(settings.opacity);
	self.window[4]:SetOpacity(settings.opacity);

	self:SaveSettings();
	self:Refresh();
	
end
	
function CaptBars:Refresh()
	local curlevel = self.player:GetLevel();

	if (self.settings.buffs.tactics) then
		if (not self.settings.buffs.tacticfade) then
			self.window[2].bar[3]:SetVisible(true);
			self.window[2].bar[3].timer:Stop();
		end
	else
		self.window[2].bar[3].timer:Stop();
		self.window[2].bar[3]:SetVisible(false);
	end
	
	if (self.settings.petban.active) then
		if (not self.settings.heralds.active) then
			self.window[4].bar[1]:SetVisible( false );
			self.window[4].bar[2]:SetVisible( true );
			self.window[4].bar[3]:SetVisible( false );
			self.settings.petban.current = 2;
		end
	else
		self.window[4]:SetVisible(false);
	end
	
	self.settings.banners.banner[1].Type = self.bannerSetup.qs[1]:GetShortcut():GetType();
	self.settings.banners.banner[1].Data = self.bannerSetup.qs[1]:GetShortcut():GetData();
	self.settings.banners.banner[2].Type = self.bannerSetup.qs[2]:GetShortcut():GetType();
	self.settings.banners.banner[2].Data = self.bannerSetup.qs[2]:GetShortcut():GetData();
	self.settings.banners.banner[3].Type = self.bannerSetup.qs[3]:GetShortcut():GetType();
	self.settings.banners.banner[3].Data = self.bannerSetup.qs[3]:GetShortcut():GetData();
	self.settings.banners.banner[4].Type = self.bannerSetup.qs[4]:GetShortcut():GetType();
	self.settings.banners.banner[4].Data = self.bannerSetup.qs[4]:GetShortcut():GetData();
	
 	self.window[4].bar[2].slot[1]:ChangeMultiShortcut(1, self.settings.banners.banner[1].Type, self.settings.banners.banner[1].Data);
	self.window[4].bar[2].slot[1]:ChangeMultiShortcut(2, self.settings.banners.banner[2].Type, self.settings.banners.banner[2].Data);
	self.window[4].bar[2].slot[1]:ChangeMultiShortcut(3, self.settings.banners.banner[3].Type, self.settings.banners.banner[3].Data);
	self.window[4].bar[3].slot[1]:ChangeMultiShortcut(1, self.settings.banners.banner[4].Type, self.settings.banners.banner[4].Data);
	
 	self.window[4].bar[2].slot[1]:SetMulti(self.settings.banners.current);
 	self.window[4].bar[3].slot[1]:SetMulti(1);
	
	self.bannerSetup:SetVisible( false );

	if (curlevel >= self.skills["IDOME"].Level) then
		self.window[2].bar[1]:SetVisible( self.settings.buffs.idome);
	else
		self.window[2].bar[1]:SetVisible(false);
	end
	
	if (curlevel >= self.skills["MotivatingSpeech"].Level) then
		self.window[2].bar[2]:SetVisible(self.settings.buffs.motivating);
	else
		self.window[2].bar[2]:SetVisible(false);
	end
	
	self.window[1].display(self.settings.defeat.active);
	self.window[2].display(self.settings.buffs.active);
	self.window[3].display(self.settings.vengence.active);
	self.window[4].display(self.settings.petban.active);
	
	Turbine.Shell.WriteLine("Kragenbars: Captain Bars refresh completed successfully.");

end