import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "Turbine.Utils";
import "KragenPlugs.KragenBars";

ChampBars = class( );

function ChampBars:Constructor()

    -- inialize the setupWindow
	self.setup = SetupWindow();
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		self.player = Turbine.Gameplay.LocalPlayer.GetInstance();
	else
		self.player = Turbine.Gameplay.LocalPlayer();
	end
	local curlevel = self.player:GetLevel();
	
	-- class settings arnt saved then load the default settings
	if (not settings.class) then
	    settings.class = "Champion";
	    self:DefaultSettings();
	    self:ShowSetup();
	else
		self.settings = settings.classinfo;
	end

	-- Build skills and level tables
	
	self.skills = { };
	self.skills["Fervour"]=			{["Level"]=4,["Hex"]="0x70003DFF"};
	self.skills["Flurry"]=			{["Level"]=4,["Hex"]="0x70003E00"};
	self.skills["Exchange"]=		{["Level"]=8,["Hex"]="0x70003E02"};
	self.skills["Ardour"]=			{["Level"]=10,["Hex"]="0x7000D46C"};
	self.skills["ArdentFlurry"]=	{["Level"]=10,["Hex"]="0x7000D606"};
	self.skills["SecondWind"]=		{["Level"]=14,["Hex"]="0x7000D47A"};
	self.skills["Glory"]=			{["Level"]=30,["Hex"]="0x7000967C"};
	self.skills["GloriousExchange"]={["Level"]=30,["Hex"]="0x7000D626"};
	self.skills["Hedge"]=			{["Level"]=38,["Hex"]="0x70003E0F"};
	self.skills["Heroics"]=			{["Level"]=40,["Hex"]="0x70009678"};
	self.skills["ControlledBurn"]=	{["Level"]=45,["Hex"]="0x70002DB5"};
	self.skills["BlockingBlades"]=	{["Level"]=48,["Hex"]="0x70009679"};
	self.skills["RedHaze"]=			{["Level"]=50,["Hex"]="0x7000967D"};
	self.skills["BloodRage"]=		{["Level"]=60,["Hex"]="0x7000F70E"};
	self.skills["TrueHeroics"]=		{["Level"]=64,["Hex"]="0x70020DF3"};
		
    self.window = { };

	-- Defeat Response Generic
	self.window[1] = Window("DEFEAT1", 3, 1, -1.5, 1, self.settings.defeat1);
    
		-- Second Wind
		self.window[1]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[1].bar[1]:AddQuickSlot(1, 1, 1, self.skills["SecondWind"].Hex);
		
		-- Heroics
		self.window[1]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[1].bar[2]:AddQuickSlot(1, 1, 1, self.skills["Heroics"].Hex);
		
		-- True Heroics
		self.window[1]:AddBar(3, 1, 1, 1, 0, true, false);
		self.window[1].bar[3]:AddQuickSlot(1, 1, 1, self.skills["TrueHeroics"].Hex);
		
		-- Red Haze
		self.window[1]:AddBar(4, 1, 1, 2, 0, true, false);
		self.window[1].bar[4]:AddQuickSlot(1, 1, 1, self.skills["RedHaze"].Hex);
		
    -- Defeat Response Generic
	self.window[2] = Window("DEFEAT2", 3, 1, -1.5, 0, self.settings.defeat2);
		
		-- Blocking Blades
		self.window[2]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[2].bar[1]:AddQuickSlot(1, 1, 1, self.skills["BlockingBlades"].Hex);
		
		-- Flurry
		self.window[2]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[2].bar[2]:AddQuickSlot(1, 1, 1, self.skills["ArdentFlurry"].Hex);
		self.window[2].bar[2]:SetZOrder(0);

		-- Exchange
		self.window[2]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[2].bar[3]:AddQuickSlot(1, 1, 1, self.skills["GloriousExchange"].Hex);
		self.window[2].bar[3]:SetZOrder(0);
		
	-- Buffs
	self.window[3] = Window("BUFFS", 2, 1, -.5, 0, self.settings.buffs);
	self.window[3]:SetZOrder( 5 );
    
		-- Flurry
		self.window[3]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[3].bar[1]:AddQuickSlot(1, 1, 1, self.skills["Flurry"].Hex);
		self.window[3].bar[1]:SetZOrder(5);
		if (curlevel < self.skills["Flurry"].Level) then
			self.window[3].bar[1]:SetVisible(false);
		end
		
		-- Exchange
		self.window[3]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[3].bar[2]:AddQuickSlot(1, 1, 1, self.skills["Exchange"].Hex);
		self.window[3].bar[2]:SetZOrder(5);
		if (curlevel < self.skills["Exchange"].Level) then
			self.window[3].bar[2]:SetVisible(false);
		end
		
		
    -- Disarm/Stun Indicator
    self.window[4] = Window("EFFECT", 1, 1, 2.5, 0, self.settings.effect);
    
		-- Blood Rage Indicator
		self.window[4]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[4].bar[1]:AddQuickSlot(1, 1, 1, self.skills["BloodRage"].Hex); -- Blood-Rage
		self.window[4].bar[1]:SetZOrder(0);
		
		-- Hedge Indicator
		self.window[4]:AddBar(2, 1, 1, 0, 0, true, false);
		self.window[4].bar[2]:AddQuickSlot(1, 1, 1, self.skills["Hedge"].Hex); -- Hedge
		self.window[4].bar[2]:SetZOrder(5);
		
	
 	-- STANCE WINDOW
	self.window[5] = Window("STANCE", 1, 1, 3.5, 1, self.settings.stance);


		-- Stance Indicator
		self.window[5]:AddBar(1, 1, 1, 0, 0, self.settings.stance.active, false);
		self.window[5].bar[1]:AddQuickSlot(1, 1, 1, ""); -- PrimaryStance
        self.window[5].bar[1].slot[1]:MultiShortcut(6, self.skills["Fervour"].Hex); -- Fervour
		self.window[5].bar[1].slot[1]:MultiShortcut(6, self.skills["Ardour"].Hex); -- Ardour
		self.window[5].bar[1].slot[1]:MultiShortcut(6, self.skills["Glory"].Hex); -- Glory
		self.window[5].bar[1].slot[1]:MultiShortcut(6, self.skills["ControlledBurn"].Hex); -- Controlled Burn
		self.window[5].bar[1].slot[1]:SetScroll(true);
		if ((self.settings.stance.primary==4 and curlevel < self.skills["ControlledBurn"].Level) or (self.settings.stance.primary==3 and curlevel < self.skills["Glory"].Level) or (self.settings.stance.primary==2 and curlevel < self.skills["Ardour"].Level)) then
			Turbine.Shell.WriteLine("Kragenbars Error: You are not high enough level to use your selected Primary Stance.  Type '/kragenbars setup' to choose a different Primary Stance.");
			self.window[5].bar[1].slot[1]:SetMulti(1);
		else
			self.window[5].bar[1].slot[1]:SetMulti(self.settings.stance.primary);
		end
		if ((self.settings.stance.secondary==4 and curlevel < self.skills["ControlledBurn"].Level) or (self.settings.stance.secondary==3 and curlevel < self.skills["Glory"].Level) or (self.settings.stance.secondary==2 and curlevel < self.skills["Ardour"].Level)) then
			Turbine.Shell.WriteLine("Kragenbars Error: You are not high enough level to use your selected Secondary Stance.  Type '/kragenbars setup' to choose a different Secondary Stance.");
		end
		if (self.settings.stance.controlled and curlevel >= self.skills["ControlledBurn"].Level) then
			self.window[5].bar[1].slot[1]:ChangeTotal(4);
		elseif (curlevel >= self.skills["Glory"].Level) then
			self.window[5].bar[1].slot[1]:ChangeTotal(3);
		elseif (curlevel >= self.skills["Ardour"].Level) then
			self.window[5].bar[1].slot[1]:ChangeTotal(2);
		elseif (curlevel >= self.skills["Fervour"].Level) then
			self.window[5].bar[1].slot[1]:ChangeTotal(1);
		else
			self.window[5].bar[1].slot[1]:ChangeTotal(0);
			self.window[5].bar[1]:SetVisible(0);
		end
		self.settings.stance.current = 0;
		
		
	-- SET WINDOW OPACITY
	self.window[1]:SetOpacity(settings.opacity);
	self.window[2]:SetOpacity(settings.opacity);
	self.window[3]:SetOpacity(settings.opacity);
	self.window[4]:SetOpacity(settings.opacity);
	self.window[5]:SetOpacity(settings.opacity);
	
	
	-- SET WINDOW VISIBILITY
	self.window[1]:SetVisible(self.settings.defeat1.active);
	self.window[2]:SetVisible(self.settings.defeat2.active);
	self.window[3]:SetVisible(self.settings.buffs.active);
	self.window[4]:SetVisible(self.settings.effect.active);
	self.window[5]:SetVisible(self.settings.stance.active);
		
	self:Refresh();
	
	-- Hook into the player to receive updates about player morale and
	-- power.
	local effects = self.player:GetEffects();

	effects.EffectAdded = function( sender, args )
		self:AddEffect( args.Index );
	end

	effects.EffectRemoved = function( sender, args )
		self:RemoveEffect( args.Effect );
	end
	
	Turbine.Shell.WriteLine("Kragenbars: Champion Bars activated.  Type: '/kragenbars setup' to change settings.");

end


function ChampBars:AddEffect( effectIndex )
	local curlevel = self.player:GetLevel();
	local addedeffect = self.player:GetEffects():Get( effectIndex );
	

	-- Defeat Response
	if (addedeffect:GetName() == "Enemy Defeat Response") then
        self.window[1]:BarActive(1 , addedeffect:GetID(), true, true);
		if (curlevel >= self.skills["SecondWind"].Level) then
			self.window[1].bar[1]:SetVisible(true);
		end
		if (curlevel >= self.skills["TrueHeroics"].Level) then
			self.window[1].bar[3]:SetVisible(true);
			self.window[1].bar[3]:SetZOrder(10);
		elseif (curlevel >= self.skills["Heroics"].Level) then
			self.window[1].bar[2]:SetVisible(true);
			self.window[1].bar[2]:SetZOrder(10);
		end
		if (curlevel >= self.skills["RedHaze"].Level) then
			self.window[1].bar[4]:SetVisible(true);
		end
        if (self.window[2].bar[1].effectID == 0 and self.settings.stance.current ~= 1 and curlevel >= self.skills["BlockingBlades"].Level) then
			self.window[2].bar[1]:SetVisible(true);
		end
        if (self.window[2].bar[2].effectID == 0 and (self.settings.stance.current == 2 or self.settings.stance.current == 4) and curlevel >= self.skills["ArdentFlurry"].Level) then
			self.window[2].bar[2]:SetVisible(true);
			self.window[2]:SetZOrder( 10 );
		end
	    if (self.window[2].bar[3].effectID == 0 and (self.settings.stance.current == 3 or self.settings.stance.current == 4)and curlevel >= self.skills["GloriousExchange"].Level) then
			self.window[2].bar[3]:SetVisible(true);
			self.window[2]:SetZOrder( 10 );
		end
        
    -- Blocking Blades
	elseif (addedeffect:GetName() == "Blocking Blades") then
        self.window[2]:BarActive(1 , addedeffect:GetID(), true, false);

	-- Ardent Flurry
	elseif (addedeffect:GetName() == "Ardent Flurry") then
  		self.window[2]:BarActive(2 , addedeffect:GetID(), true, false);

    -- Glorious Exchange
	elseif (addedeffect:GetName() == "Glorious Exchange") then
        self.window[2]:BarActive(3 , addedeffect:GetID(), true, false);
        
	-- Flurry
	elseif (addedeffect:GetName() == "Flurry" or addedeffect:GetName() == "Improved Flurry") then
	    self.window[3]:BarActive(1 , addedeffect:GetID(), true, false);
	    if (self.settings.buffs.timer) then
			self.window[3].bar[1]:StartTimer(addedeffect:GetDuration() * .70, true);
		end
		
    -- Exchange
 	elseif (addedeffect:GetName() == "Exchange of Blows" or addedeffect:GetName() == "Improved Exchange of Blows") then
	    self.window[3]:BarActive(2 , addedeffect:GetID(), true, false);
	    if (self.settings.buffs.timer) then
			self.window[3].bar[2]:StartTimer(addedeffect:GetDuration() * .70, true);
		end
		
    -- Stunned, Dazed, Knocked Down
	elseif ((addedeffect:GetName() == "Stunned" or addedeffect:GetName() == "Dazed" or addedeffect:GetName() == "Knocked Down" or addedeffect:GetName() == "Knocked Out" or addedeffect:GetName() == "Rooted") and curlevel >= self.skills["BloodRage"].Level) then
  		self.window[4]:BarActive(1 , addedeffect:GetID(), true, true);
  		self.window[4].bar[1]:SetZOrder(10);

	-- Disarmed
	elseif (addedeffect:GetName() == "Primary Weapon: Disarmed" and curlevel >= self.skills["Hedge"].Level) then
  		self.window[4]:BarActive(2 , addedeffect:GetID(), true, true);

   -- Stance Change
	elseif (addedeffect:GetName() == "Champion's Fervour" or addedeffect:GetName() == "Ardour" or addedeffect:GetName() == "Glory" or addedeffect:GetName() == "Controlled Burn") then
  		self.window[5]:BarActive(1, addedeffect:GetID(), true, true);
		self.window[5].bar[1]:SetHover( true );

		if (addedeffect:GetName() == "Champion's Fervour") then
			self.settings.stance.current = 1;
			if (self.window[3].bar[1].effectID == 0) then
				self.window[3].bar[1]:SetVisible( self.settings.buffs.flurry and curlevel >= self.skills["Flurry"].Level  );
			end
 			if (self.window[3].bar[2].effectID == 0) then
				self.window[3].bar[2]:SetVisible( self.settings.buffs.exchange and curlevel >= self.skills["Exchange"].Level );
			end

		elseif (addedeffect:GetName() == "Ardour") then
			self.settings.stance.current = 2;
			self.window[3].bar[1]:SetVisible( false );
 			if (self.window[3].bar[2].effectID == 0) then
				self.window[3].bar[2]:SetVisible( self.settings.buffs.exchange and curlevel >= self.skills["Exchange"].Level );
				self.window[3].bar[2]:SetOpacity( settings.opacity );
			end
		elseif (addedeffect:GetName() == "Glory") then
			self.settings.stance.current = 3;
			self.window[3].bar[2]:SetVisible( false );
			if (self.window[3].bar[1].effectID == 0) then
				self.window[3].bar[1]:SetVisible( self.settings.buffs.flurry and curlevel >= self.skills["Flurry"].Level  );
				self.window[3].bar[1]:SetOpacity( settings.opacity );
			end
		elseif (addedeffect:GetName() == "Controlled Burn") then
			self.settings.stance.current = 4;
			self.window[3].bar[1].timer:Stop();
			self.window[3].bar[2].timer:Stop();
			self.window[3].bar[1]:SetVisible( false );
			self.window[3].bar[2]:SetVisible( false );
		end

		if (self.settings.stance.current ~= self.settings.stance.primary) then
			if ((self.settings.stance.primary==4 and curlevel < self.skills["ControlledBurn"].Level) or (self.settings.stance.primary==3 and curlevel < self.skills["Glory"].Level) or (self.settings.stance.primary==2 and curlevel < self.skills["Ardour"].Level)) then
				Turbine.Shell.WriteLine("Kragenbars Error: You are not high enough level to use your selected Primary Stance.  Type '/kragenbars setup' to choose a different Primary Stance.");
				self.window[5].bar[1].slot[1]:SetMulti(1);
			else
				self.window[5].bar[1].slot[1]:SetMulti(self.settings.stance.primary);
			end
		else
			if ((self.settings.stance.secondary==4 and curlevel < self.skills["ControlledBurn"].Level) or (self.settings.stance.secondary==3 and curlevel < self.skills["Glory"].Level) or (self.settings.stance.secondary==2 and curlevel < self.skills["Ardour"].Level)) then
				Turbine.Shell.WriteLine("Kragenbars Error: You are not high enough level to use your selected Secondary Stance.  Type '/kragenbars setup' to choose a different Secondary Stance.");
				self.window[5].bar[1].slot[1]:SetMulti(1);
			else
				self.window[5].bar[1].slot[1]:SetMulti(self.settings.stance.secondary);
			end
		end

    end
end

function ChampBars:RemoveEffect( effect )
	local curlevel = self.player:GetLevel();

	-- Defeat Response
	if (effect:GetName() == "Enemy Defeat Response") then
		self.window[1]:BarActive(1 , effect:GetID(), false, false);
		-- self.window[1]:BarActive(2 , effect:GetID(), false, false);
		-- self.window[1]:BarActive(3 , effect:GetID(), false, false);
		-- self.window[1]:BarActive(4 , effect:GetID(), false, false);
		if (self.window[1].bar[1].effectID == 0) then
			self.window[1].bar[2]:SetVisible(false);
			self.window[1].bar[3]:SetVisible(false);
			self.window[1].bar[4]:SetVisible(false);
			self.window[2].bar[1]:SetVisible(false);
			self.window[2].bar[2]:SetVisible(false);
			self.window[2].bar[3]:SetVisible(false);
			self.window[2]:SetZOrder( 0 );
		end

	-- Blocking Blades
    elseif (effect:GetName() == "Blocking Blades") then
        self.window[2]:BarActive(1 , effect:GetID(), false, false);
        if (self.window[1].bar[1].effectID ~= 0 and self.window[2].bar[1].effectID == 0 and self.settings.stance.current ~= 1) then
			self.window[2].bar[1]:SetVisible(true);
		end
        
    -- Ardent Flurry
    elseif (effect:GetName() == "Ardent Flurry") then
     	self.window[2]:BarActive(2 , effect:GetID(), false, false);
     	if (self.window[1].bar[1].effectID ~= 0 and self.window[2].bar[2].effectID == 0 and (self.settings.stance.current == 2 or self.stance.current == 4)) then
			self.window[2].bar[2]:SetVisible(true);
		end

	-- Glorious Exchange
    elseif (effect:GetName() == "Glorious Exchange") then
        self.window[2]:BarActive(3 , effect:GetID(), false, false);
	    if (self.window[1].bar[1].effectID ~= 0 and self.window[2].bar[3].effectID == 0 and (self.settings.stance.current == 3 or self.stance.current == 4)) then
			self.window[2].bar[3]:SetVisible(true);
		end
		
    -- Flurry
	elseif (effect:GetName() == "Flurry" or effect:GetName() == "Improved Flurry") then
        self.window[3]:BarActive(1 , effect:GetID(), false, false);
        if (self.settings.buffs.flurry and self.window[3].bar[1].effectID == 0 and (self.settings.stance.current ~= 2 and self.settings.stance.current ~= 4)) then
			self.window[3].bar[1]:SetVisible( true );
			self.window[3].bar[1]:SetOpacity( settings.opacity );
		end


	-- Exchange
	elseif (effect:GetName() == "Exchange of Blows" or effect:GetName() == "Improved Exchange of Blows") then
        self.window[3]:BarActive(2 , effect:GetID(), false, false);
        if (self.settings.buffs.exchange and self.window[3].bar[2].effectID == 0 and (self.settings.stance.current ~= 3 and self.settings.stance.current ~= 4)) then
			self.window[3].bar[2]:SetVisible( true );
			self.window[3].bar[2]:SetOpacity( settings.opacity );
		end

    -- Stunned, Dazed or Knocked Down
	elseif (effect:GetName() == "Stunned" or effect:GetName() == "Dazed" or effect:GetName() == "Knocked Down" or effect:GetName() == "Knocked Out" or effect:GetName() == "Rooted") then
  		self.window[4]:BarActive(1 , effect:GetID(), false, false);
		if (self.window[4].bar[1].effectID == 0) then
		    self.window[4].bar[1]:SetZOrder(0);
		end

	-- Disarmed
	elseif (effect:GetName() == "Primary Weapon: Disarmed") then
        self.window[4]:BarActive(2 , effect:GetID(), false, false);

	-- Stance Change
 	elseif (effect:GetName() == "Champion's Fervour" or effect:GetName() == "Ardour" or effect:GetName() == "Glory" or effect:GetName() == "Controlled Burn") then
     	self.window[5]:BarActive(1, effect:GetID(), false, true);
    	if (self.window[5].bar[1].effectID == 0) then
			self.window[5].bar[1]:SetHover( false );
			if ((self.settings.stance.primary==4 and curlevel < self.skills["ControlledBurn"].Level) or (self.settings.stance.primary==3 and curlevel < self.skills["Glory"].Level) or (self.settings.stance.primary==2 and curlevel < self.skills["Ardour"].Level)) then
				Turbine.Shell.WriteLine("Kragenbars Error: You are not high enough level to use your selected Primary Stance.  Type '/kragenbars setup' to choose a different Primary Stance.");
				self.window[5].bar[1].slot[1]:SetMulti(1);
			else
				self.window[5].bar[1].slot[1]:SetMulti(self.settings.stance.primary);
			end
			self.settings.stance.current = 0;
			
			if (self.window[3].bar[1].effectID == 0) then
				self.window[3].bar[1]:SetVisible( self.settings.buffs.flurry and curlevel >= self.skills["Flurry"].Level );
			end
 			if (self.window[3].bar[2].effectID == 0) then
				self.window[3].bar[2]:SetVisible( self.settings.buffs.exchange and curlevel >= self.skills["Exchange"].Level );
			end
		end


	end
end

function ChampBars:DefaultSettings()
	self.settings = { };

	self.settings.defeat1 = { };
	self.settings.defeat1.active = true;
	self.settings.defeat1.x = 0;
	self.settings.defeat1.y = 0;

	self.settings.defeat2 = { };
	self.settings.defeat2.active = true;
	self.settings.defeat2.x = 0;
	self.settings.defeat2.y = 0;

	self.settings.buffs = { };
	self.settings.buffs.active = true;
	self.settings.buffs.x = 0;
	self.settings.buffs.y = 0;
	self.settings.buffs.timer = true;
	self.settings.buffs.flurry = true;
	self.settings.buffs.exchange = true;

	self.settings.effect = { };
	self.settings.effect.active = true;
	self.settings.effect.x = 0;
	self.settings.effect.y = 0;

	self.settings.stance = { };
	self.settings.stance.active = true;
	self.settings.stance.x = 0;
	self.settings.stance.y = 0;
	self.settings.stance.current = 0;
	self.settings.stance.primary = 1;
	self.settings.stance.secondary = 1;
	self.settings.stance.controlled = true;
end

function ChampBars:SaveSettings()
	self.settings.defeat1.x, self.settings.defeat1.y = self.window[1]:GetPosition();
	self.settings.defeat2.x, self.settings.defeat2.y = self.window[2]:GetPosition();
	self.settings.buffs.x, self.settings.buffs.y = self.window[3]:GetPosition();
	self.settings.effect.x, self.settings.effect.y = self.window[4]:GetPosition();
	self.settings.stance.x, self.settings.stance.y = self.window[5]:GetPosition();
	settings.classinfo = self.settings;
	SaveSettings();
end

function ChampBars:ShowSetup()
    self.setup:SetVisible(true);
	self.setup.slider1:SetValue(settings.opacity);
	
	self.setup.checkbox1:SetText("Defeat Response 1");
	self.setup.checkbox2:SetText("Defeat Response 2");
	self.setup.checkbox3:SetText("Buffs");
  	self.setup.checkbox4:SetText("Stun/Disarm Effect (60/38)");
    self.setup.checkbox5:SetText("Stance Slot");
    self.setup.checkbox6:SetText("Controlled Burn (45)");
    self.setup.checkbox7:SetText("Flurry (4)");
    self.setup.checkbox8:SetText("Exchange of Blows (8)");
    self.setup.checkbox9:SetVisible( false );
    self.setup.checkbox10:SetVisible( false );
    self.setup.checkbox11:SetText("Early Warning");

  	self.setup.checkbox1:SetChecked( self.settings.defeat1.active );
  	self.setup.checkbox2:SetChecked( self.settings.defeat2.active );
  	self.setup.checkbox3:SetChecked( self.settings.buffs.active );
  	self.setup.checkbox4:SetChecked( self.settings.effect.active );
  	self.setup.checkbox5:SetChecked( self.settings.stance.active );
  	self.setup.checkbox6:SetChecked( self.settings.stance.controlled );
  	self.setup.checkbox7:SetChecked( self.settings.buffs.flurry );
  	self.setup.checkbox8:SetChecked( self.settings.buffs.exchange );
  	self.setup.checkbox11:SetChecked( self.settings.buffs.timer );
  	
    il={"Fervour (4)", "Ardour (10)", "Glory (30)", "Controlled Burn (45)"};
	self.setup.dropdown1 = KragenPlugs.DUInterface.DropDownBox(il);
	self.setup.dropdown1:SetParent(self.setup.bg);
	self.setup.dropdown1:SetPosition(20,305);
	self.setup.dropdown1:SetZOrder(99); -- can be less, but should be higher than others to allow the drop down to cover other elements
  	il={"Fervour (4)", "Ardour (10)", "Glory (30)", "Controlled Burn (45)"};
	self.setup.dropdown2 = KragenPlugs.DUInterface.DropDownBox(il);
	self.setup.dropdown2:SetParent(self.setup.bg);
	self.setup.dropdown2:SetPosition(215,305);
	self.setup.dropdown2:SetZOrder(99); -- can be less, but should be higher than others to allow the drop down to cover other elements

	self.setup.dropdown1.SetIndex(self.settings.stance.primary);
    self.setup.dropdown2.SetIndex(self.settings.stance.secondary);
	self.setup:SetText("KB: Champion");
end

function ChampBars:SetupClosing()

    self.settings.defeat1.active = self.setup.checkbox1:GetChecked();
	self.settings.defeat2.active = self.setup.checkbox2:GetChecked();
	self.settings.buffs.active = self.setup.checkbox3:GetChecked();
	self.settings.effect.active = self.setup.checkbox4:GetChecked();
	self.settings.stance.active = self.setup.checkbox5:GetChecked();
	self.settings.stance.primary = self.setup.dropdown1:GetIndex();
	self.settings.stance.secondary = self.setup.dropdown2:GetIndex();
	self.settings.stance.controlled = self.setup.checkbox6:GetChecked();
	self.settings.buffs.flurry = self.setup.checkbox7:GetChecked();
	self.settings.buffs.exchange = self.setup.checkbox8:GetChecked();
	self.settings.buffs.timer = self.setup.checkbox11:GetChecked();
	
	-- SET WINDOW OPACITY
	self.window[1]:SetOpacity(settings.opacity);
	self.window[2]:SetOpacity(settings.opacity);
	self.window[3]:SetOpacity(settings.opacity);
	self.window[4]:SetOpacity(settings.opacity);
	self.window[5]:SetOpacity(settings.opacity);

	self:SaveSettings();
	self:Refresh();

end

function ChampBars:Refresh()
	local curlevel = self.player:GetLevel();
	
	self.window[1].bar[1]:SetVisible(false);
	self.window[1].bar[2]:SetVisible(false);
	self.window[1].bar[3]:SetVisible(false);
	self.window[1].bar[4]:SetVisible(false);
	self.window[2].bar[1]:SetVisible(false);
	self.window[2].bar[2]:SetVisible(false);
	self.window[2].bar[3]:SetVisible(false);
	self.window[4].bar[1]:SetVisible(false);
	self.window[4].bar[2]:SetVisible(false);

	if ((self.settings.stance.primary==4 and curlevel < self.skills["ControlledBurn"].Level) or (self.settings.stance.primary==3 and curlevel < self.skills["Glory"].Level) or (self.settings.stance.primary==2 and curlevel < self.skills["Ardour"].Level)) then
		Turbine.Shell.WriteLine("Kragenbars Error: You are not high enough level to use your selected Primary Stance.  Type '/kragenbars setup' to choose a different Primary Stance.");
		if (self.settings.stance.current == 0) then
			self.window[5].bar[1].slot[1]:SetMulti(1);
		end
	elseif (self.settings.stance.current ~= self.settings.stance.primary) then
		self.window[5].bar[1].slot[1]:SetMulti(self.settings.stance.primary);
	end
	if ((self.settings.stance.secondary==4 and curlevel < self.skills["ControlledBurn"].Level) or (self.settings.stance.secondary==3 and curlevel < self.skills["Glory"].Level) or (self.settings.stance.secondary==2 and curlevel < self.skills["Ardour"].Level)) then
		Turbine.Shell.WriteLine("Kragenbars Error: You are not high enough level to use your selected Secondary Stance.  Type '/kragenbars setup' to choose a different Secondary Stance.");
		if (self.settings.stance.current == self.settings.stance.primary) then
			self.window[5].bar[1].slot[1]:SetMulti(1);
		end
	elseif (self.settings.stance.current == self.settings.stance.primary) then
		self.window[5].bar[1].slot[1]:SetMulti(self.settings.stance.secondary);
	end

	self.window[3].bar[1]:SetVisible(self.settings.buffs.flurry and curlevel >= self.skills["Flurry"].Level and self.window[3].bar[1].effectID == 0 and (self.settings.stance.current ~= 2 and self.settings.stance.current ~= 4));
	self.window[3].bar[2]:SetVisible(self.settings.buffs.exchange and curlevel >= self.skills["Exchange"].Level and self.window[3].bar[2].effectID == 0 and (self.settings.stance.current ~= 3 and self.settings.stance.current ~= 4));
	self.window[3].bar[1]:SetOpacity( settings.opacity );
	self.window[3].bar[2]:SetOpacity( settings.opacity );

	self.window[1].display(self.settings.defeat1.active);
	self.window[2].display(self.settings.defeat2.active);
	self.window[3].display(self.settings.buffs.active);
	self.window[4].display(self.settings.effect.active);
	if (self.settings.stance.controlled and curlevel >= self.skills["ControlledBurn"].Level) then
		self.window[5].bar[1].slot[1]:ChangeTotal(4);
		self.window[5].display(self.settings.stance.active);
		self.window[5].bar[1]:SetVisible(self.settings.stance.active);
	elseif (curlevel >= self.skills["Glory"].Level) then
	   	self.window[5].bar[1].slot[1]:ChangeTotal(3);
		self.window[5].display(self.settings.stance.active);
		self.window[5].bar[1]:SetVisible(self.settings.stance.active);
	elseif (curlevel >= self.skills["Ardour"].Level) then
		self.window[5].bar[1].slot[1]:ChangeTotal(2);
		self.window[5].display(self.settings.stance.active);
		self.window[5].bar[1]:SetVisible(self.settings.stance.active);
	elseif (curlevel >= self.skills["Fervour"].Level) then
		self.window[5].bar[1].slot[1]:ChangeTotal(1);
		self.window[5].display(self.settings.stance.active);
		self.window[5].bar[1]:SetVisible(self.settings.stance.active);
	else
		self.window[5].bar[1].slot[1]:ChangeTotal(0);
		self.window[5].bar[1]:SetVisible(0);
	end
	Turbine.Shell.WriteLine("Kragenbars: Champion Bars refresh completed successfully.");

end