import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "Turbine.Utils";
import "KragenPlugs.KragenBars";

GuardBars = class( );

function GuardBars:Constructor()

 	-- inialize the setupWindow
	self.setup = SetupWindow();
	self.GuardSetup = GuardSetup();
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		self.player = Turbine.Gameplay.LocalPlayer.GetInstance();
	else
		self.player = Turbine.Gameplay.LocalPlayer();
	end
	local curlevel = self.player:GetLevel();

	-- class settings arent saved then load the default settings
	if (not settings.class) then
	    settings.class = "Guardian";
	    self:DefaultSettings();
	    self:ShowSetup();
	else
		self.settings = settings.classinfo;
	end

	-- Build skills and level tables
	
	self.skills = { }; -- NOTE: GET HEX VALUES
	self.skills["Bash"]=					{["Level"]=10,["Hex"]="0x70003E7C"};
	self.skills["BrutalAssault"]=			{["Level"]=56,["Hex"]="0x70003E7A"};
	self.skills["BrutalCharge"]=			{["Level"]=62,["Hex"]="0x70003E7A"};
	self.skills["CatchaBreath"]=			{["Level"]=16,["Hex"]="0x70003E7A"};
	self.skills["Challenge"]=				{["Level"]=16,["Hex"]="0x70003E7A"};
	self.skills["Charge"]=					{["Level"]=48,["Hex"]="0x70003E7A"};
	self.skills["DeepBreath"]=				{["Level"]=34,["Hex"]="0x70003E7A"};
	self.skills["Engage"]=					{["Level"]=42,["Hex"]="0x70003E7A"};
	self.skills["ForceOpening"]=			{["Level"]=30,["Hex"]="0x70003E7A"};
	self.skills["FraytheEdge"]=				{["Level"]=40,["Hex"]="0x70003E7A"};
	self.skills["GuardiansDefense"]=		{["Level"]=4,["Hex"]="0x70003E7A"};
	self.skills["GuardiansParry"]=			{["Level"]=12,["Hex"]="0x70003E7A"};
	self.skills["GuardiansPledge"]=			{["Level"]=20,["Hex"]="0x70003E7A"};
	self.skills["GuardiansPromise"]=		{["Level"]=38,["Hex"]="0x70003E7A"};
	self.skills["GuardiansWard"]=			{["Level"]=1,["Hex"]="0x70003E7A"};
	self.skills["IgnorethePain"]=			{["Level"]=44,["Hex"]="0x70003E7A"};
	self.skills["ImprovedShieldBlow"]=		{["Level"]=54,["Hex"]="0x70003E7A"};
	self.skills["ImprovedSting"]=			{["Level"]=52,["Hex"]="0x70003E7A"};
	self.skills["LetFly"]=					{["Level"]=30,["Hex"]="0x70003E7A"};
	self.skills["LitanyofDefiance"]=		{["Level"]=60,["Hex"]="0x70003E7A"};
	self.skills["Overpower"]=				{["Level"]=10,["Hex"]="0x70003E7A"};
	self.skills["Overwhelm"]=				{["Level"]=8,["Hex"]="0x70003E7A"};
	self.skills["Protection"]=				{["Level"]=24,["Hex"]="0x70003E7A"};
	self.skills["Retaliation"]=				{["Level"]=8,["Hex"]="0x70003E7A"};
	self.skills["SalttheWound"]=			{["Level"]=22,["Hex"]="0x70003E7A"};
	self.skills["ShieldWall"]=				{["Level"]=50,["Hex"]="0x70003E7A"};
	self.skills["Shieldblow"]=				{["Level"]=1,["Hex"]="0x70003E7A"};
	self.skills["Shieldswipe"]=				{["Level"]=2,["Hex"]="0x70003E7A"};
	self.skills["Shieldtaunt"]=				{["Level"]=22,["Hex"]="0x70003E7A"};
	self.skills["Stagger"]=					{["Level"]=46,["Hex"]="0x70003E7A"};
	self.skills["Stamp"]=					{["Level"]=32,["Hex"]="0x70003E7A"};
	self.skills["Sting"]=					{["Level"]=1,["Hex"]="0x70003E7A"};
	self.skills["SummonTinker"]=			{["Level"]=26,["Hex"]="0x70003E7A"};
	self.skills["SweepingCut"]=				{["Level"]=4,["Hex"]="0x70003E7A"};
	self.skills["TaketoHeart"]=				{["Level"]=58,["Hex"]="0x70003E7A"};
	self.skills["ThrillofDanger"]=			{["Level"]=26,["Hex"]="0x70003E7A"};
	self.skills["Thrust"]=					{["Level"]=18,["Hex"]="0x70003E7A"};
	self.skills["TurntheTables"]=			{["Level"]=36,["Hex"]="0x70003E7A"};
	self.skills["VexingBlow"]=				{["Level"]=6,["Hex"]="0x70003E7A"};
	self.skills["WarriorsFortitude"]=		{["Level"]=64,["Hex"]="0x70003E7A"};
	self.skills["WarriorsHeart"]=			{["Level"]=30,["Hex"]="0x70003E7A"};
	self.skills["WhirlingRetaliation"]=		{["Level"]=14,["Hex"]="0x70003E7A"};
	self.skills["ChallengetheDarkness"]=	{["Level"]=39,["Hex"]="0x70003E7A"};
	self.skills["Shieldsmash"]=				{["Level"]=39,["Hex"]="0x70003E7A"};
	self.skills["GuardiansThreat"]=			{["Level"]=39,["Hex"]="0x70003E7A"};
	self.skills["TotheKing"]=				{["Level"]=45,["Hex"]="0x70003E7A"};

    
    self.window = { };

    -- Tier 1 Ballads
    --self.window[1] = Window("T1Ballads", 3, 1, 0, 0, self.settings.t1ballads);

		--self.window[1]:AddBar(1, 1, 1, 0, 0, true, false);
		--self.window[1].bar[1]:AddQuickSlot(1, 1, 1, self.skills["BalladofVigour"].Hex);
		
		--self.window[1]:AddBar(2, 1, 1, 1, 0, true, false);
		--self.window[1].bar[2]:AddQuickSlot(1, 1, 1, self.skills["BalladofSteel"].Hex);
		
		--self.window[1]:AddBar(3, 1, 1, 2, 0, true, false);
		--self.window[1].bar[3]:AddQuickSlot(1, 1, 1, self.skills["BalladofResonance"].Hex);
		
	-- Tales
	--self.window[11] = Window("Tales", 1, 1, 4, 3, self.settings.tales);
	
		--self.window[11]:AddBar(1, 1, 1, 0, 0, true, false);
		--self.window[11].bar[1]:AddQuickSlot(1, 1, 1, "");
		--self.window[11].bar[1].slot[1]:MultiShortcut(6, self.skills["TaleofHeroism"].Hex);
		--self.window[11].bar[1].slot[1]:MultiShortcut(6, self.skills["TaleofBattle"].Hex);
		--self.window[11].bar[1].slot[1]:MultiShortcut(6, self.skills["TaleofWarding"].Hex);
		--self.window[11].bar[1].slot[1]:MultiShortcut(6, self.skills["TaleofFrostandFlame"].Hex);
		--self.window[11].bar[1].slot[1]:MultiShortcut(6, self.skills["TaleofWardingandHeroism"].Hex);
		--self.window[11].bar[1].slot[1]:MultiShortcut(6, self.skills["TaleofFrostandFlamesBattle"].Hex);
		--self.window[11].bar[1].slot[1]:SetScroll(true);
       -- self.window[11].bar[1].slot[1]:SetMulti(1);

	self:Refresh();
	
	-- Hook into the player to receive updates about player morale and
	-- power.
	local effects = self.player:GetEffects();

	effects.EffectAdded = function( sender, args )
		self:AddEffect( args.Index );
	end

	effects.EffectRemoved = function( sender, args )
		self:RemoveEffect( args.Effect );
	end

	self.player.InCombatChanged = function( sender, args )
      	if (self.player:IsInCombat() == false) then
			--self.window[8].bar[1]:SetVisible(false);
			--self.window[8].bar[2]:SetVisible(false);
		elseif (self.player:IsInCombat() == true ) then
		--self.window[8].bar[1]:SetVisible(self.settings.dethreat.active and curlevel >= self.skills["SongofSoothing"].Level);
		--self.window[8].bar[2]:SetVisible(self.settings.dethreat.active and curlevel >= self.skills["StillasDeath"].Level);
		end
	end
	
end


function GuardBars:AddEffect( effectIndex )
	local curlevel = self.player:GetLevel();
	local addedeffect = self.player:GetEffects():Get( effectIndex );

	-- Show T2Ballads on T1Ballad Cast
	--if (addedeffect:GetName() == "Ballad Tier 1") then
		--if (self.settings.ballads.active) then
			--self.window[2]:BarActive(1 , addedeffect:GetID(), true, true);
			--self.window[2].bar[1]:SetVisible(curlevel >= self.skills["BalladofSwiftness"].Level);
			--self.window[2].bar[2]:SetVisible(curlevel >= self.skills["BalladofBalance"].Level);
			--self.window[2].bar[3]:SetVisible(curlevel >= self.skills["BalladoftheStout"].Level);
		--end
	
	-- Show Silence if Silenced
	--elseif (addedeffect:GetName() == "Silenced") then
		--if (self.settings.silence.active) then
			--self.window[14]:BarActive(1 , addedeffect:GetID(), true, true);
			--if (curlevel >= self.skills["ImprovedCryoftheChorus"].Level) then
				--self.window[14].bar[2]:SetVisible(true);
				--self.window[14].bar[2]:SetZOrder(10);
				--self.window[14].bar[1]:SetVisible(false);
				--self.window[14].bar[1]:SetZOrder(0);
			--elseif (curlevel >= self.skills["CryoftheChorus"].Level) then
				--self.window[14].bar[2]:SetVisible(false);
				--self.window[14].bar[2]:SetZOrder(0);
				--self.window[14].bar[1]:SetVisible(true);
				--self.window[14].bar[1]:SetZOrder(10);
			--else
				--self.window[14].bar[2]:SetVisible(false);
				--self.window[14].bar[2]:SetZOrder(0);
				--self.window[14].bar[1]:SetVisible(false);
				--self.window[14].bar[1]:SetZOrder(0);
			--end
		--end

	-- Dim Tale if active
	--elseif (addedeffect:GetName() == "Tale of Heroism" or addedeffect:GetName() == "Tale of Battle" or addedeffect:GetName() == "Tale of Warding" or addedeffect:GetName() == "Tale of Frost and Flame" or addedeffect:GetName() == "Tale of Warding and Heroism" or addedeffect:GetName() == "Tale of Frost and Flame's Battle") then
		--if (self.settings.tales.active) then
			--self.window[11]:BarActive(1 , addedeffect:GetID(), true, true);
			--self.window[11].bar[1]:SetHover( true );
			--if (addedeffect:GetName() == "Tale of Heroism") then
				--self.settings.tales.current = 1;
			--elseif (addedeffect:GetName() == "Tale of Battle") then
				--self.settings.tales.current = 2;
			--elseif (addedeffect:GetName() == "Tale of Warding") then
				--self.settings.tales.current = 3;
			--elseif (addedeffect:GetName() == "Tale of Frost and Flame") then
				--self.settings.tales.current = 4;
			--elseif (addedeffect:GetName() == "Tale of Warding and Heroism") then
				--self.settings.tales.current = 5;
			--elseif (addedeffect:GetName() == "Tale of Frost and Flame's Battle") then
				--self.settings.tales.current = 6;
			--end
		--end

	--end
end


function GuardBars:RemoveEffect( effect )
	local curlevel = self.player:GetLevel();

	-- Hide T2Ballads on T1Ballad Expire
	--if (effect:GetName() == "Ballad Tier 1") then
		--self.window[2]:BarActive(1 , effect:GetID(), false, false);
		--if (self.window[2].bar[1].effectID == 0) then
			--self.window[2].bar[2]:SetVisible(false);
			--self.window[2].bar[3]:SetVisible(false);
			--self.window[2]:SetZOrder( 0 );
		--end
		
	-- Hide Silence when Silence cured/expired
	--elseif (effect:GetName() == "Silenced") then
		--self.window[14]:BarActive(1 , effect:GetID(), false, false);
		--if (self.window[14].bar[1].effectID == 0) then
			--self.window[14].bar[2]:SetVisible(false);
		--end

	--elseif (effect:GetName() == "Tale of Heroism" or effect:GetName() == "Tale of Battle" or effect:GetName() == "Tale of Warding" or effect:GetName() == "Tale of Frost and Flame" or effect:GetName() == "Tale of Warding and Heroism" or effect:GetName() == "Tale of Frost and Flame's Battle") then
		--if (self.settings.tales.active) then
			--self.window[11]:BarActive(1 , effect:GetID(), true, true);
			--self.window[11].bar[1]:SetHover( false );
		--end
	
	--end
end


function GuardBars:DefaultSettings()
	self.settings = { };

	--self.settings.ballads = { };
	--self.settings.ballads.active = true;
	
	--self.settings.t1ballads = { };
	--self.settings.t1ballads.x = 0;
	--self.settings.t1ballads.y = 0;

	--self.settings.anthems = { };
	--self.settings.anthems.active = true;
	--self.settings.anthems.x = 0;
	--self.settings.anthems.y = 0;
	--self.settings.anthems.wizards = false;

end


function GuardBars:SaveSettings()
	--self.settings.t1ballads.x, self.settings.t1ballads.y = self.window[1]:GetPosition();
	--self.settings.t2ballads.x, self.settings.t2ballads.y = self.window[2]:GetPosition();
	--self.settings.t3ballads.x, self.settings.t3ballads.y = self.window[3]:GetPosition();
	--self.settings.anthems.x, self.settings.anthems.y = self.window[4]:GetPosition();
	--self.settings.warspeech.x, self.settings.warspeech.y = self.window[5]:GetPosition();

	Turbine.Shell.WriteLine("Kragenbars: Guardian Bars settings saved successfully.");

	settings.classinfo = self.settings;
	SaveSettings();
	
end


function GuardBars:ShowSetup()
	self.setup:SetVisible(true);
	self.setup.slider1:SetValue(settings.opacity);
	
	self.setup.checkbox1:SetVisible(false);
	self.setup.checkbox2:SetVisible(false);
	self.setup.checkbox3:SetVisible(false);
  	self.setup.checkbox4:SetVisible(false);
   	self.setup.checkbox5:SetVisible(false);
  	self.setup.checkbox6:SetVisible(false);
  	self.setup.checkbox7:SetVisible(false);
  	self.setup.checkbox8:SetVisible(false);
    self.setup.checkbox9:SetVisible(false);
    self.setup.checkbox10:SetVisible(false);
    self.setup.checkbox11:SetVisible(false);
    self.setup.psTitle:SetVisible( false );
    self.setup.ssTitle:SetVisible( false );
	self.setup:SetText("KB: Guardian");

	--self.GuardSetup:SetVisible(true);
	--self.GuardSetup.checkbox1:SetText("Ballads");
  	--self.GuardSetup.checkbox1:SetChecked( self.settings.ballads.active );
	--self.GuardSetup.checkbox2:SetText("Anthems");
  	--self.GuardSetup.checkbox2:SetChecked( self.settings.anthems.active );

end


function GuardBars:SetupClosing()
    --self.settings.ballads.active = self.GuardSetup.checkbox1:GetChecked();
    --self.settings.anthems.active = self.GuardSetup.checkbox2:GetChecked();
    --self.settings.warspeech.active = self.GuardSetup.checkbox3:GetChecked();
    --self.settings.calls.active = self.GuardSetup.checkbox4:GetChecked();
	--self.GuardSetup:SetVisible(false);
	
	self:SaveSettings();
	self:Refresh();
	
end
	
	
function GuardBars:Refresh()
	local curlevel = self.player:GetLevel();

		-- SET WINDOW OPACITY
	--self.window[1]:SetOpacity(settings.opacity);
	--self.window[2]:SetOpacity(settings.opacity);
	--self.window[3]:SetOpacity(settings.opacity);
	--self.window[4]:SetOpacity(settings.opacity);
	--self.window[5]:SetOpacity(settings.opacity);
	--self.window[6]:SetOpacity(settings.opacity);

	-- SET WINDOW VISIBILITY
	--self.window[1]:SetVisible(self.settings.ballads.active);
	--T1Ballads Level Check
	--if (curlevel < self.skills["BalladofVigour"].Level) then
		--self.window[1].bar[1]:SetVisible(false);
	--end
	--if (curlevel < self.skills["BalladofSteel"].Level) then
		--self.window[1].bar[2]:SetVisible(false);
	--end
	--if (curlevel < self.skills["BalladofResonance"].Level) then
		--self.window[1].bar[3]:SetVisible(false);
	--end
	
	--self.window[2]:SetVisible(self.settings.ballads.active);
	--self.window[2].bar[1]:SetVisible(false);
	--self.window[2].bar[2]:SetVisible(false);
	--self.window[2].bar[3]:SetVisible(false);
	
	--self.window[9]:SetVisible(self.settings.melee.active);
	--self.window[9].bar[1]:SetVisible(curlevel >= self.skills["NobleCause"].Level);
	--if (curlevel >= self.skills["ImprovedHeraldsStrike"].Level) then
		--self.window[9].bar[3]:SetVisible(self.settings.melee.active);
		--self.window[9].bar[3]:SetZOrder(10);
		--self.window[9].bar[2]:SetVisible(false);
		--self.window[9].bar[2]:SetZOrder(0);
	--elseif (curlevel >= self.skills["HeraldsStrike"].Level) then
		--self.window[9].bar[2]:SetVisible(self.settings.melee.active);
		--self.window[9].bar[2]:SetZOrder(10);
		--self.window[9].bar[3]:SetVisible(false);
		--self.window[9].bar[3]:SetZOrder(0);
	--else
		--self.window[9].bar[2]:SetVisible(false);
		--self.window[9].bar[2]:SetZOrder(10);
		--self.window[9].bar[3]:SetVisible(false);
		--self.window[9].bar[3]:SetZOrder(0);
	--end
	
	--self.window[11]:SetVisible(self.settings.tales.active);
	--self.window[11].bar[1].slot[1]:SetMulti(self.settings.tales.current);
	--if (self.settings.tales.master and curlevel >= self.skills["TaleofWardingandHeroism"].Level) then
		--self.window[11].bar[1].slot[1]:ChangeTotal(6);
	--elseif (curlevel >= self.skills["TaleofFrostandFlame"].Level) then
		--self.window[11].bar[1].slot[1]:ChangeTotal(4);
	--elseif (curlevel >= self.skills["TaleofWarding"].Level) then
		--self.window[11].bar[1].slot[1]:ChangeTotal(3);
	--elseif (curlevel >= self.skills["TaleofBattle"].Level) then
		--self.window[11].bar[1].slot[1]:ChangeTotal(2);
	--elseif (curlevel >= self.skills["TaleofHeroism"].Level) then
		--self.window[11].bar[1].slot[1]:ChangeTotal(1);
	-- else
		-- self.window[11].bar[1].slot[1]:ChangeTotal(0);
		-- self.window[11].bar[1]:SetVisible(false);
	-- end
	
	if (self.player:IsInCombat() == false) then
		--self.window[8].bar[1]:SetVisible(false);
		--self.window[8].bar[2]:SetVisible(false);
	elseif (self.player:IsInCombat() == true ) then
		--self.window[8].bar[1]:SetVisible(self.settings.dethreat.active and curlevel >= self.skills["SongofSoothing"].Level);
		--self.window[8].bar[2]:SetVisible(self.settings.dethreat.active and curlevel >= self.skills["StillasDeath"].Level);
	end
	
	Turbine.Shell.WriteLine("Kragenbars: Minstrel Bars refresh completed successfully.");

end