import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "Turbine.Utils";
import "KragenPlugs.KragenBars";

MiniBars = class( );

function MiniBars:Constructor()

 	-- inialize the setupWindow
	self.setup = SetupWindow();
	self.MiniSetup = MiniSetup();
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		self.player = Turbine.Gameplay.LocalPlayer.GetInstance();
	else
		self.player = Turbine.Gameplay.LocalPlayer();
	end
	local curlevel = self.player:GetLevel();

	-- class settings arnt saved then load the default settings
	if (not settings.class) then
	    settings.class = "Minstrel";
	    self:DefaultSettings();
	    self:ShowSetup();
	else
		self.settings = settings.classinfo;
		if (settings.vers ~= mainvars.vers) then
			self:UpdateSettings();
		end
	end

	-- Build skills and level tables
	
	self.skills = { };
	self.skills["BalladofVigour"]=			{["Level"]=1,["Hex"]="0x70003E7C"};
	self.skills["HeraldsStrike"]=			{["Level"]=1,["Hex"]="0x70003E7A"};
	self.skills["RaisetheSpirit"]=			{["Level"]=1,["Hex"]="0x70003E7B"};
	self.skills["BalladofSwiftness"]=		{["Level"]=2,["Hex"]="0x70003E7F"};
	self.skills["PiercingCry"]=				{["Level"]=2,["Hex"]="0x70003E7D"};
	self.skills["BalladofSteel"]=			{["Level"]=4,["Hex"]="0x70003E7E"};
	self.skills["BalladofWar"]=				{["Level"]=6,["Hex"]="0x7000317F"};
	self.skills["EchoesofBattle"]=			{["Level"]=6,["Hex"]="0x7000B697"};
	self.skills["BalladofResonance"]=		{["Level"]=8,["Hex"]="0x700031A8"};
	self.skills["BalladofUnshakeableWill"]=	{["Level"]=8,["Hex"]="0x70003E80"};
	self.skills["Warspeech"]=				{["Level"]=10,["Hex"]="0x7000B699"};
	self.skills["BalladofBalance"]=			{["Level"]=12,["Hex"]="0x70003E83"};
	self.skills["CryoftheValar"]=			{["Level"]=12,["Hex"]="0x70003E82"};
	self.skills["CallofOrome"]=				{["Level"]=14,["Hex"]="0x7000B69A"};
	self.skills["NobleCause"]=				{["Level"]=14,["Hex"]="0x70003E84"};
	self.skills["BolsterCourage"]=			{["Level"]=16,["Hex"]="0x70003E85"};
	self.skills["SongoftheDead"]=			{["Level"]=16,["Hex"]="0x70003E87"};
	self.skills["AnthemoftheFreePeoples"]=	{["Level"]=18,["Hex"]="0x70003E88"};
	self.skills["SongofRestoration"]=		{["Level"]=18,["Hex"]="0x70003E86"};
	self.skills["InspireFellows"]=			{["Level"]=20,["Hex"]="0x70003E81"};
	self.skills["EnliveningGrace"]=			{["Level"]=20,["Hex"]="0x700031AD"};
	self.skills["TaleofHeroism"]=			{["Level"]=22,["Hex"]="0x70003E89"};
	self.skills["AnthemofCompassion"]=		{["Level"]=24,["Hex"]="0x70003E8A"};
	self.skills["CryoftheChorus"]=			{["Level"]=26,["Hex"]="0x700031B2"};
	self.skills["CureFear"]=				{["Level"]=26,["Hex"]="0x70003E8B"};
	self.skills["SongofSoothing"]=			{["Level"]=28,["Hex"]="0x700031B7"};
	self.skills["TriumphantSpirit"]=		{["Level"]=30,["Hex"]="0x70003E8C"};
	self.skills["SongofAid"]=				{["Level"]=30,["Hex"]="0x7000318C"};
	self.skills["BalladofFlame"]=			{["Level"]=32,["Hex"]="0x70003E8D"};
	self.skills["TaleofBattle"]=			{["Level"]=32,["Hex"]="0x7000B661"};
	self.skills["CalloftheSecondAge"]=		{["Level"]=34,["Hex"]="0x7000B69B"};
	self.skills["SongofDistraction"]=		{["Level"]=34,["Hex"]="0x70003E8E"};
	self.skills["BalladoftheStout"]=		{["Level"]=36,["Hex"]="0x70003E8F"};
	self.skills["ChordofSalvation"]=		{["Level"]=38,["Hex"]="0x7000BC01"};
	self.skills["StillasDeath"]=			{["Level"]=38,["Hex"]="0x70003E90"};
	self.skills["AnthemoftheWizards"]=		{["Level"]=39,["Hex"]="0x70001270"};
	self.skills["SongoftheHopefulHeart"]=	{["Level"]=39,["Hex"]="0x7000125F"};
	self.skills["Rally"]=					{["Level"]=39,["Hex"]="0x70001251"};
	self.skills["AnthemoftheValar"]=		{["Level"]=40,["Hex"]="0x70003184"};
	self.skills["LayoftheHammerhand"]=		{["Level"]=42,["Hex"]="0x70003E91"};
	self.skills["TaleofWarding"]=			{["Level"]=44,["Hex"]="0x7000B660"};
	self.skills["FellowshipsHeart"]=		{["Level"]=45,["Hex"]="0x70006CEB"};
	self.skills["CalltotheFellowship"]=		{["Level"]=46,["Hex"]="0x7000B69D"};
	self.skills["GiftoftheHammerhand"]=		{["Level"]=48,["Hex"]="0x7000B69E"};
	self.skills["CalltoGreatness"]=			{["Level"]=50,["Hex"]="0x7000B69C"};
	self.skills["ImprovedHeraldsStrike"]=	{["Level"]=52,["Hex"]="0x70015A3C"};
	self.skills["ImprovedCryoftheChorus"]=	{["Level"]=54,["Hex"]="0x7000F260"};
	self.skills["TaleofWardingandHeroism"]=	{["Level"]=55,["Hex"]="0x7000F21B"};
	self.skills["TaleofFrostandFlamesBattle"]={["Level"]=55,["Hex"]="0x7000F21C"};
	self.skills["CalltoFate"]=				{["Level"]=56,["Hex"]="0x7000F250"};
	self.skills["TaleofFrostandFlame"]=		{["Level"]=58,["Hex"]="0x7000F216"};
	self.skills["SoliloquyofSpirit"]=		{["Level"]=60,["Hex"]="0x7000F1F4"};
	self.skills["ChorusofRestoration"]=		{["Level"]=62,["Hex"]="0x7000F25F"};
	self.skills["LyricoftheHammerhand"]=	{["Level"]=64,["Hex"]="0x70020DF9"};

    
    self.window = { };

    -- Tier 1 Ballads
    self.window[1] = Window("T1Ballads", 3, 1, 0, 0, self.settings.t1ballads);

		self.window[1]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[1].bar[1]:AddQuickSlot(1, 1, 1, self.skills["BalladofVigour"].Hex);
		
		self.window[1]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[1].bar[2]:AddQuickSlot(1, 1, 1, self.skills["BalladofSteel"].Hex);
		
		self.window[1]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[1].bar[3]:AddQuickSlot(1, 1, 1, self.skills["BalladofResonance"].Hex);
		
	-- Tier 2 Ballads
	self.window[2] = Window("T2Ballads", 3, 1, 0, 1, self.settings.t2ballads);
	
		self.window[2]:AddBar(1, 1, 1, 1, 0, true, false);
		self.window[2].bar[1]:AddQuickSlot(1, 1, 1, self.skills["BalladofSwiftness"].Hex);
		
		self.window[2]:AddBar(2, 1, 1, 0, 0, true, false);
		self.window[2].bar[2]:AddQuickSlot(1, 1, 1, self.skills["BalladofBalance"].Hex);
		
		self.window[2]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[2].bar[3]:AddQuickSlot(1, 1, 1, self.skills["BalladoftheStout"].Hex);
		
	-- Tier 3 Ballads
	self.window[3] = Window("T3Ballads", 3, 1, 0, 2, self.settings.t3ballads);
	
		self.window[3]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[3].bar[1]:AddQuickSlot(1, 1, 1, self.skills["BalladofWar"].Hex);
		
		self.window[3]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[3].bar[2]:AddQuickSlot(1, 1, 1, self.skills["BalladofUnshakeableWill"].Hex);
		
		self.window[3]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[3].bar[3]:AddQuickSlot(1, 1, 1, self.skills["BalladofFlame"].Hex);

	-- Anthems
	self.window[4] = Window("Anthems", 4, 1, 0, 3, self.settings.anthems);
	
		self.window[4]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[4].bar[1]:AddQuickSlot(1, 1, 1, self.skills["AnthemoftheFreePeoples"].Hex);
		
		self.window[4]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[4].bar[2]:AddQuickSlot(1, 1, 1, self.skills["AnthemofCompassion"].Hex);
		
		self.window[4]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[4].bar[3]:AddQuickSlot(1, 1, 1, self.skills["AnthemoftheValar"].Hex);
		
		self.window[4]:AddBar(4, 1, 1, 3, 0, true, false);
		self.window[4].bar[4]:AddQuickSlot(1, 1, 1, self.skills["AnthemoftheWizards"].Hex);
	
	-- War-speech
	self.window[5] = Window("Warspeech", 1, 1, 4, 0, self.settings.warspeech);
	
		self.window[5]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[5].bar[1]:AddQuickSlot(1, 1, 1, self.skills["Warspeech"].Hex);

	-- Calls
	self.window[6] = Window("Calls", 3, 1, 5, 0, self.settings.calls);
	
		self.window[6]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[6].bar[1]:AddQuickSlot(1, 1, 1, self.skills["CallofOrome"].Hex);
		
		self.window[6]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[6].bar[2]:AddQuickSlot(1, 1, 1, self.skills["CalloftheSecondAge"].Hex);
		
		self.window[6]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[6].bar[3]:AddQuickSlot(1, 1, 1, self.skills["CalltoFate"].Hex);

	-- Damage
	self.window[7] = Window("Damage", 2, 1, 4, 1, self.settings.damage);
	
		self.window[7]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[7].bar[1]:AddQuickSlot(1, 1, 1, self.skills["EchoesofBattle"].Hex);
		
		self.window[7]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[7].bar[2]:AddQuickSlot(1, 1, 1, self.skills["PiercingCry"].Hex);

	-- Dethreat
	self.window[8] = Window("Dethreat", 2, 1, 4, 2, self.settings.dethreat);
	
		self.window[8]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[8].bar[1]:AddQuickSlot(1, 1, 1, self.skills["SongofSoothing"].Hex);
		
		self.window[8]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[8].bar[2]:AddQuickSlot(1, 1, 1, self.skills["StillasDeath"].Hex);
		
	-- Melee
	self.window[9] = Window("Melee", 2, 1, 6, 1, self.settings.melee);
	
		self.window[9]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[9].bar[1]:AddQuickSlot(1, 1, 1, self.skills["NobleCause"].Hex);
		
		self.window[9]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[9].bar[2]:AddQuickSlot(1, 1, 1, self.skills["HeraldsStrike"].Hex);

		self.window[9]:AddBar(3, 1, 1, 1, 0, true, false);
		self.window[9].bar[3]:AddQuickSlot(1, 1, 1, self.skills["ImprovedHeraldsStrike"].Hex);
		
	-- Heals
	self.window[10] = Window("Heals", 6, 1, 0, 4, self.settings.heals);
	
		self.window[10]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[10].bar[1]:AddQuickSlot(1, 1, 1, self.skills["RaisetheSpirit"].Hex);
		
		self.window[10]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[10].bar[2]:AddQuickSlot(1, 1, 1, self.skills["BolsterCourage"].Hex);

		self.window[10]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[10].bar[3]:AddQuickSlot(1, 1, 1, self.skills["InspireFellows"].Hex);

		self.window[10]:AddBar(4, 1, 1, 3, 0, true, false);
		self.window[10].bar[4]:AddQuickSlot(1, 1, 1, self.skills["TriumphantSpirit"].Hex);

		self.window[10]:AddBar(5, 1, 1, 4, 0, true, false);
		self.window[10].bar[5]:AddQuickSlot(1, 1, 1, self.skills["ChordofSalvation"].Hex);

		self.window[10]:AddBar(6, 1, 1, 5, 0, true, false);
		self.window[10].bar[6]:AddQuickSlot(1, 1, 1, self.skills["SoliloquyofSpirit"].Hex);

	-- Tales
	self.window[11] = Window("Tales", 1, 1, 4, 3, self.settings.tales);
	
		self.window[11]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[11].bar[1]:AddQuickSlot(1, 1, 1, "");
		self.window[11].bar[1].slot[1]:MultiShortcut(6, self.skills["TaleofHeroism"].Hex);
		self.window[11].bar[1].slot[1]:MultiShortcut(6, self.skills["TaleofBattle"].Hex);
		self.window[11].bar[1].slot[1]:MultiShortcut(6, self.skills["TaleofWarding"].Hex);
		self.window[11].bar[1].slot[1]:MultiShortcut(6, self.skills["TaleofFrostandFlame"].Hex);
		self.window[11].bar[1].slot[1]:MultiShortcut(6, self.skills["TaleofWardingandHeroism"].Hex);
		self.window[11].bar[1].slot[1]:MultiShortcut(6, self.skills["TaleofFrostandFlamesBattle"].Hex);
		self.window[11].bar[1].slot[1]:SetScroll(true);
        self.window[11].bar[1].slot[1]:SetMulti(1);

	-- Utility
	self.window[12] = Window("Utility", 5, 1, 0, 5, self.settings.utility);
	
		self.window[12]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[12].bar[1]:AddQuickSlot(1, 1, 1, self.skills["SongofAid"].Hex);
		
		self.window[12]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[12].bar[2]:AddQuickSlot(1, 1, 1, self.skills["CalltotheFellowship"].Hex);

		self.window[12]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[12].bar[3]:AddQuickSlot(1, 1, 1, self.skills["GiftoftheHammerhand"].Hex);

		self.window[12]:AddBar(4, 1, 1, 3, 0, true, false);
		self.window[12].bar[4]:AddQuickSlot(1, 1, 1, self.skills["CalltoGreatness"].Hex);

		self.window[12]:AddBar(5, 1, 1, 4, 0, true, false);
		self.window[12].bar[5]:AddQuickSlot(1, 1, 1, self.skills["SongoftheHopefulHeart"].Hex);

	-- Rez
	self.window[13] = Window("Rez", 5, 1, 0, 6, self.settings.rez);
	
		self.window[13]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[13].bar[1]:AddQuickSlot(1, 1, 1, self.skills["SongofRestoration"].Hex);
		
		self.window[13]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[13].bar[2]:AddQuickSlot(1, 1, 1, self.skills["EnliveningGrace"].Hex);

		self.window[13]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[13].bar[3]:AddQuickSlot(1, 1, 1, self.skills["ChorusofRestoration"].Hex);

		self.window[13]:AddBar(4, 1, 1, 3, 0, true, false);
		self.window[13].bar[4]:AddQuickSlot(1, 1, 1, self.skills["Rally"].Hex);

	-- Silence
	self.window[14] = Window("Silence", 1, 1, 5, 5, self.settings.silence);
	
		self.window[14]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[14].bar[1]:AddQuickSlot(1, 1, 1, self.skills["CryoftheChorus"].Hex);
		
		self.window[14]:AddBar(2, 1, 1, 0, 0, true, false);
		self.window[14].bar[2]:AddQuickSlot(1, 1, 1, self.skills["ImprovedCryoftheChorus"].Hex);

	-- CC
	self.window[15] = Window("CC", 3, 1, 0, 7, self.settings.crowdcontrol);
	
		self.window[15]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[15].bar[1]:AddQuickSlot(1, 1, 1, self.skills["CryoftheValar"].Hex);
		
		self.window[15]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[15].bar[2]:AddQuickSlot(1, 1, 1, self.skills["SongoftheDead"].Hex);

		self.window[15]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[15].bar[3]:AddQuickSlot(1, 1, 1, self.skills["SongofDistraction"].Hex);

	-- CureFear
	self.window[16] = Window("Fear", 2, 1, 4, 6, self.settings.fear);
	
		self.window[16]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[16].bar[1]:AddQuickSlot(1, 1, 1, self.skills["CureFear"].Hex);
		
		self.window[16]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[16].bar[2]:AddQuickSlot(1, 1, 1, self.skills["FellowshipsHeart"].Hex);
		
	-- PowerShield
	self.window[17] = Window("Shield", 1, 1, 6, 2, self.settings.shield);
	
		self.window[17]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[17].bar[1]:AddQuickSlot(1, 1, 1, self.skills["LayoftheHammerhand"].Hex);
		
		self.window[17]:AddBar(2, 1, 1, 0, 0, true, false);
		self.window[17].bar[2]:AddQuickSlot(1, 1, 1, self.skills["LyricoftheHammerhand"].Hex);

	self:Refresh();
	
	-- Hook into the player to receive updates about player morale and
	-- power.
	local effects = self.player:GetEffects();

	effects.EffectAdded = function( sender, args )
		self:AddEffect( args.Index );
	end

	effects.EffectRemoved = function( sender, args )
		self:RemoveEffect( args.Effect );
	end

	self.player.InCombatChanged = function( sender, args )
      	if (self.player:IsInCombat() == false) then
			self.window[8].bar[1]:SetVisible(false);
			self.window[8].bar[2]:SetVisible(false);
		elseif (self.player:IsInCombat() == true ) then
		self.window[8].bar[1]:SetVisible(self.settings.dethreat.active and curlevel >= self.skills["SongofSoothing"].Level);
		self.window[8].bar[2]:SetVisible(self.settings.dethreat.active and curlevel >= self.skills["StillasDeath"].Level);
		end
	end
	
end


function MiniBars:AddEffect( effectIndex )
	local curlevel = self.player:GetLevel();
	local addedeffect = self.player:GetEffects():Get( effectIndex );

	-- Show T2Ballads on T1Ballad Cast
	if (addedeffect:GetName() == "Ballad Tier 1") then
		if (self.settings.ballads.active) then
			self.window[2]:BarActive(1 , addedeffect:GetID(), true, true);
			self.window[2].bar[1]:SetVisible(curlevel >= self.skills["BalladofSwiftness"].Level);
			self.window[2].bar[2]:SetVisible(curlevel >= self.skills["BalladofBalance"].Level);
			self.window[2].bar[3]:SetVisible(curlevel >= self.skills["BalladoftheStout"].Level);
		end
	
	-- Show T3 Ballads on T2Ballad Cast
	elseif (addedeffect:GetName() == "Ballad Tier 2") then
		if (self.settings.ballads.active) then
			self.window[3]:BarActive(1 , addedeffect:GetID(), true, true);
			self.window[3].bar[1]:SetVisible(curlevel >= self.skills["BalladofWar"].Level);
			self.window[3].bar[2]:SetVisible(curlevel >= self.skills["BalladofUnshakeableWill"].Level);
			self.window[3].bar[3]:SetVisible(curlevel >= self.skills["BalladofFlame"].Level);
		end
	
	-- Show Anthems on T3Ballad Cast
	elseif (addedeffect:GetName() == "Ballad Tier 3") then
		if (self.settings.anthems.active) then
			self.window[4]:BarActive(1 , addedeffect:GetID(), true, true);
			self.window[4].bar[1]:SetVisible(curlevel >= self.skills["AnthemoftheFreePeoples"].Level);
			self.window[4].bar[2]:SetVisible(curlevel >= self.skills["AnthemofCompassion"].Level);
			self.window[4].bar[3]:SetVisible(curlevel >= self.skills["AnthemoftheValar"].Level);
			self.window[4].bar[3]:SetVisible(curlevel >= self.skills["AnthemoftheWizards"].Level and self.settings.anthems.wizards);
		end
	
	-- While Warspeech show Calls
	elseif (addedeffect:GetName() == "War-speech") then
		if (self.settings.calls.active) then
			self.window[6]:BarActive(1 , addedeffect:GetID(), true, true);
			self.window[6].bar[1]:SetVisible(curlevel >= self.skills["CallofOrome"].Level);
			self.window[6].bar[2]:SetVisible(curlevel >= self.skills["CalloftheSecondAge"].Level);
			self.window[6].bar[3]:SetVisible(curlevel >= self.skills["CalltoFate"].Level);
		end

	-- Show Silence if Silenced
	elseif (addedeffect:GetName() == "Silenced") then
		if (self.settings.silence.active) then
			self.window[14]:BarActive(1 , addedeffect:GetID(), true, true);
			if (curlevel >= self.skills["ImprovedCryoftheChorus"].Level) then
				self.window[14].bar[2]:SetVisible(true);
				self.window[14].bar[2]:SetZOrder(10);
				self.window[14].bar[1]:SetVisible(false);
				self.window[14].bar[1]:SetZOrder(0);
			elseif (curlevel >= self.skills["CryoftheChorus"].Level) then
				self.window[14].bar[2]:SetVisible(false);
				self.window[14].bar[2]:SetZOrder(0);
				self.window[14].bar[1]:SetVisible(true);
				self.window[14].bar[1]:SetZOrder(10);
			else
				self.window[14].bar[2]:SetVisible(false);
				self.window[14].bar[2]:SetZOrder(0);
				self.window[14].bar[1]:SetVisible(false);
				self.window[14].bar[1]:SetZOrder(0);
			end
		end

	-- Dim Tale if active
	elseif (addedeffect:GetName() == "Tale of Heroism" or addedeffect:GetName() == "Tale of Battle" or addedeffect:GetName() == "Tale of Warding" or addedeffect:GetName() == "Tale of Frost and Flame" or addedeffect:GetName() == "Tale of Warding and Heroism" or addedeffect:GetName() == "Tale of Frost and Flame's Battle") then
		if (self.settings.tales.active) then
			self.window[11]:BarActive(1 , addedeffect:GetID(), true, true);
			self.window[11].bar[1]:SetHover( true );
			if (addedeffect:GetName() == "Tale of Heroism") then
				self.settings.tales.current = 1;
			elseif (addedeffect:GetName() == "Tale of Battle") then
				self.settings.tales.current = 2;
			elseif (addedeffect:GetName() == "Tale of Warding") then
				self.settings.tales.current = 3;
			elseif (addedeffect:GetName() == "Tale of Frost and Flame") then
				self.settings.tales.current = 4;
			elseif (addedeffect:GetName() == "Tale of Warding and Heroism") then
				self.settings.tales.current = 5;
			elseif (addedeffect:GetName() == "Tale of Frost and Flame's Battle") then
				self.settings.tales.current = 6;
			end
		end

	end
end


function MiniBars:RemoveEffect( effect )
	local curlevel = self.player:GetLevel();

	-- Hide T2Ballads on T1Ballad Expire
	if (effect:GetName() == "Ballad Tier 1") then
		self.window[2]:BarActive(1 , effect:GetID(), false, false);
		if (self.window[2].bar[1].effectID == 0) then
			self.window[2].bar[2]:SetVisible(false);
			self.window[2].bar[3]:SetVisible(false);
			self.window[2]:SetZOrder( 0 );
		end
		
	-- Hide T3Ballads on T2Ballad Expire
	elseif (effect:GetName() == "Ballad Tier 2") then
		self.window[3]:BarActive(1 , effect:GetID(), false, false);
		if (self.window[3].bar[1].effectID == 0) then
			self.window[3].bar[2]:SetVisible(false);
			self.window[3].bar[3]:SetVisible(false);
			self.window[3]:SetZOrder( 0 );
		end

	-- Hide Anthems on T3Ballad Expire
	elseif (effect:GetName() == "Ballad Tier 3") then
		self.window[4]:BarActive(1 , effect:GetID(), false, false);
		if (self.window[4].bar[1].effectID == 0) then
			self.window[4].bar[2]:SetVisible(false);
			self.window[4].bar[3]:SetVisible(false);
			self.window[4].bar[4]:SetVisible(false);
			self.window[4]:SetZOrder( 0 );
		end

	-- Hide Calls on Warspeech remove
	elseif (effect:GetName() == "War-speech") then
		self.window[6]:BarActive(1 , effect:GetID(), false, false);
		if (self.window[6].bar[1].effectID == 0) then
			self.window[6].bar[2]:SetVisible(false);
			self.window[6].bar[3]:SetVisible(false);
			self.window[6]:SetZOrder( 0 );
		end

	-- Hide Silence when Silence cured/expired
	elseif (effect:GetName() == "Silenced") then
		self.window[14]:BarActive(1 , effect:GetID(), false, false);
		if (self.window[14].bar[1].effectID == 0) then
			self.window[14].bar[2]:SetVisible(false);
		end

	elseif (effect:GetName() == "Tale of Heroism" or effect:GetName() == "Tale of Battle" or effect:GetName() == "Tale of Warding" or effect:GetName() == "Tale of Frost and Flame" or effect:GetName() == "Tale of Warding and Heroism" or effect:GetName() == "Tale of Frost and Flame's Battle") then
		if (self.settings.tales.active) then
			self.window[11]:BarActive(1 , effect:GetID(), true, true);
			self.window[11].bar[1]:SetHover( false );
		end
	
	end
end


function MiniBars:DefaultSettings()
	self.settings = { };

	self.settings.ballads = { };
	self.settings.ballads.active = true;
	
	self.settings.t1ballads = { };
	self.settings.t1ballads.x = 0;
	self.settings.t1ballads.y = 0;

	self.settings.t2ballads = { };
	self.settings.t2ballads.x = 0;
	self.settings.t2ballads.y = 0;

	self.settings.t3ballads = { };
	self.settings.t3ballads.x = 0;
	self.settings.t3ballads.y = 0;

	self.settings.anthems = { };
	self.settings.anthems.active = true;
	self.settings.anthems.x = 0;
	self.settings.anthems.y = 0;
	self.settings.anthems.wizards = false;

	self.settings.warspeech = { };
	self.settings.warspeech.active = true;
	self.settings.warspeech.x = 0;
	self.settings.warspeech.y = 0;

	self.settings.calls = { };
	self.settings.calls.active = true;
	self.settings.calls.x = 0;
	self.settings.calls.y = 0;
	
	self.settings.damage = { };
	self.settings.damage.active = true;
	self.settings.damage.x = 0;
	self.settings.damage.y = 0;

	self.settings.dethreat = { };
	self.settings.dethreat.active = true;
	self.settings.dethreat.x = 0;
	self.settings.dethreat.y = 0;
	
	self.settings.melee = { };
	self.settings.melee.active = true;
	self.settings.melee.x = 0;
	self.settings.melee.y = 0;
	
	self.settings.heals = { };
	self.settings.heals.active = true;
	self.settings.heals.x = 0;
	self.settings.heals.y = 0;
	
	self.settings.tales = { };
	self.settings.tales.active = true;
	self.settings.tales.x = 0;
	self.settings.tales.y = 0;
	self.settings.tales.master = false;
	self.settings.tales.current = 1;
	
	self.settings.utility = { };
	self.settings.utility.active = true;
	self.settings.utility.x = 0;
	self.settings.utility.y = 0;
	self.settings.utility.songhopeful = false;
	
	self.settings.rez = { };
	self.settings.rez.active = true;
	self.settings.rez.x = 0;
	self.settings.rez.y = 0;
	self.settings.rez.rally = false;
	
	self.settings.silence = { };
	self.settings.silence.active = true;
	self.settings.silence.x = 0;
	self.settings.silence.y = 0;
	
	self.settings.crowdcontrol = { };
	self.settings.crowdcontrol.active = true;
	self.settings.crowdcontrol.x = 0;
	self.settings.crowdcontrol.y = 0;
	
	self.settings.fear = { };
	self.settings.fear.active = true;
	self.settings.fear.x = 0;
	self.settings.fear.y = 0;
	self.settings.fear.fellowship = false;
	
	self.settings.shield = { };
	self.settings.shield.active = true;
	self.settings.shield.x = 0;
	self.settings.shield.y = 0;

end


function MiniBars:UpdateSettings()
	settings.vers = mainvars.vers;
	
end


function MiniBars:SaveSettings()
	self.settings.t1ballads.x, self.settings.t1ballads.y = self.window[1]:GetPosition();
	self.settings.t2ballads.x, self.settings.t2ballads.y = self.window[2]:GetPosition();
	self.settings.t3ballads.x, self.settings.t3ballads.y = self.window[3]:GetPosition();
	self.settings.anthems.x, self.settings.anthems.y = self.window[4]:GetPosition();
	self.settings.warspeech.x, self.settings.warspeech.y = self.window[5]:GetPosition();
	self.settings.calls.x, self.settings.calls.y = self.window[6]:GetPosition();
	self.settings.damage.x, self.settings.damage.y = self.window[7]:GetPosition();
	self.settings.dethreat.x, self.settings.dethreat.y = self.window[8]:GetPosition();
	self.settings.melee.x, self.settings.melee.y = self.window[9]:GetPosition();
	self.settings.heals.x, self.settings.heals.y = self.window[10]:GetPosition();
	self.settings.tales.x, self.settings.tales.y = self.window[11]:GetPosition();
	self.settings.utility.x, self.settings.utility.y = self.window[12]:GetPosition();
	self.settings.rez.x, self.settings.rez.y = self.window[13]:GetPosition();
	self.settings.silence.x, self.settings.silence.y = self.window[14]:GetPosition();
	self.settings.crowdcontrol.x, self.settings.crowdcontrol.y = self.window[15]:GetPosition();
	self.settings.fear.x, self.settings.fear.y = self.window[16]:GetPosition();
	self.settings.shield.x, self.settings.shield.y = self.window[17]:GetPosition();

	Turbine.Shell.WriteLine("Kragenbars: Minstrel Bars settings saved successfully.");

	settings.classinfo = self.settings;
	SaveSettings();
	
end


function MiniBars:ShowSetup()
	self.setup:SetVisible(true);
	self.setup.slider1:SetValue(settings.opacity);
	
	self.setup.checkbox1:SetVisible(false);
	self.setup.checkbox2:SetVisible(false);
	self.setup.checkbox3:SetVisible(false);
  	self.setup.checkbox4:SetVisible(false);
   	self.setup.checkbox5:SetVisible(false);
  	self.setup.checkbox6:SetVisible(false);
  	self.setup.checkbox7:SetVisible(false);
  	self.setup.checkbox8:SetVisible(false);
    self.setup.checkbox9:SetVisible(false);
    self.setup.checkbox10:SetVisible(false);
    self.setup.checkbox11:SetVisible(false);
    self.setup.psTitle:SetVisible( false );
    self.setup.ssTitle:SetVisible( false );
	self.setup:SetText("KB: Minstrel");

	self.MiniSetup:SetVisible(true);
	self.MiniSetup.checkbox1:SetText("Ballads");
  	self.MiniSetup.checkbox1:SetChecked( self.settings.ballads.active );
	self.MiniSetup.checkbox2:SetText("Anthems");
  	self.MiniSetup.checkbox2:SetChecked( self.settings.anthems.active );
	self.MiniSetup.checkbox3:SetText("Warspeech");
  	self.MiniSetup.checkbox3:SetChecked( self.settings.warspeech.active );
	self.MiniSetup.checkbox4:SetText("Calls");
  	self.MiniSetup.checkbox4:SetChecked( self.settings.calls.active );
	self.MiniSetup.checkbox5:SetText("Damage");
  	self.MiniSetup.checkbox5:SetChecked( self.settings.damage.active );
	self.MiniSetup.checkbox6:SetText("Dethreat");
  	self.MiniSetup.checkbox6:SetChecked( self.settings.dethreat.active );
	self.MiniSetup.checkbox7:SetText("Melee");
  	self.MiniSetup.checkbox7:SetChecked( self.settings.melee.active );
	self.MiniSetup.checkbox8:SetText("Tales");
  	self.MiniSetup.checkbox8:SetChecked( self.settings.tales.active );
	self.MiniSetup.checkbox9:SetText("Utility");
  	self.MiniSetup.checkbox9:SetChecked( self.settings.utility.active );
	self.MiniSetup.checkbox10:SetText("Rez");
  	self.MiniSetup.checkbox10:SetChecked( self.settings.rez.active );
	self.MiniSetup.checkbox11:SetText("Silence");
  	self.MiniSetup.checkbox11:SetChecked( self.settings.silence.active );
	self.MiniSetup.checkbox12:SetText("Crowd Control");
  	self.MiniSetup.checkbox12:SetChecked( self.settings.crowdcontrol.active );
	self.MiniSetup.checkbox13:SetText("Fear");
  	self.MiniSetup.checkbox13:SetChecked( self.settings.fear.active );
	self.MiniSetup.checkbox14:SetText("Shield");
  	self.MiniSetup.checkbox14:SetChecked( self.settings.shield.active );
	self.MiniSetup.checkbox15:SetText("Heals");
  	self.MiniSetup.checkbox15:SetChecked( self.settings.heals.active );
	self.MiniSetup.checkbox16:SetText("Rally!");
  	self.MiniSetup.checkbox16:SetChecked( self.settings.rez.rally );
	self.MiniSetup.checkbox17:SetText("Anthem of the Wizards");
  	self.MiniSetup.checkbox17:SetChecked( self.settings.anthems.wizards );
	self.MiniSetup.checkbox17:SetSize(380,16);
	self.MiniSetup.checkbox17.title:SetSize(380-22,16);
	self.MiniSetup.checkbox18:SetText("Song of the Hopeful Heart");
  	self.MiniSetup.checkbox18:SetChecked( self.settings.utility.songhopeful );
	self.MiniSetup.checkbox18:SetSize(380,16);
	self.MiniSetup.checkbox18.title:SetSize(380-22,16);
	self.MiniSetup.checkbox19:SetText("Fellowship's Heart");
  	self.MiniSetup.checkbox19:SetChecked( self.settings.fear.fellowship );
	self.MiniSetup.checkbox19:SetSize(380,16);
	self.MiniSetup.checkbox19.title:SetSize(380-22,16);
	self.MiniSetup.checkbox20:SetText("Master of Tales");
  	self.MiniSetup.checkbox20:SetChecked( self.settings.tales.master );
	self.MiniSetup.checkbox20:SetSize(380,16);
	self.MiniSetup.checkbox20.title:SetSize(380-22,16);

end


function MiniBars:SetupClosing()
    self.settings.ballads.active = self.MiniSetup.checkbox1:GetChecked();
    self.settings.anthems.active = self.MiniSetup.checkbox2:GetChecked();
    self.settings.warspeech.active = self.MiniSetup.checkbox3:GetChecked();
    self.settings.calls.active = self.MiniSetup.checkbox4:GetChecked();
    self.settings.damage.active = self.MiniSetup.checkbox5:GetChecked();
    self.settings.dethreat.active = self.MiniSetup.checkbox6:GetChecked();
    self.settings.melee.active = self.MiniSetup.checkbox7:GetChecked();
    self.settings.tales.active = self.MiniSetup.checkbox8:GetChecked();
    self.settings.utility.active = self.MiniSetup.checkbox9:GetChecked();
    self.settings.rez.active = self.MiniSetup.checkbox10:GetChecked();
    self.settings.silence.active = self.MiniSetup.checkbox11:GetChecked();
    self.settings.crowdcontrol.active = self.MiniSetup.checkbox12:GetChecked();
    self.settings.fear.active = self.MiniSetup.checkbox13:GetChecked();
    self.settings.shield.active = self.MiniSetup.checkbox14:GetChecked();
    self.settings.heals.active = self.MiniSetup.checkbox15:GetChecked();
    self.settings.rez.rally = self.MiniSetup.checkbox16:GetChecked();
    self.settings.anthems.wizards = self.MiniSetup.checkbox17:GetChecked();
    self.settings.utility.songhopeful = self.MiniSetup.checkbox18:GetChecked();
    self.settings.fear.fellowship = self.MiniSetup.checkbox19:GetChecked();
    self.settings.tales.master = self.MiniSetup.checkbox20:GetChecked();
	self.MiniSetup:SetVisible(false);
	
	self:SaveSettings();
	self:Refresh();
	
end
	
	
function MiniBars:Refresh()
	local curlevel = self.player:GetLevel();

		-- SET WINDOW OPACITY
	self.window[1]:SetOpacity(settings.opacity);
	self.window[2]:SetOpacity(settings.opacity);
	self.window[3]:SetOpacity(settings.opacity);
	self.window[4]:SetOpacity(settings.opacity);
	self.window[5]:SetOpacity(settings.opacity);
	self.window[6]:SetOpacity(settings.opacity);
	self.window[7]:SetOpacity(settings.opacity);
	self.window[8]:SetOpacity(settings.opacity);
	self.window[9]:SetOpacity(settings.opacity);
	self.window[10]:SetOpacity(settings.opacity);
	self.window[11]:SetOpacity(settings.opacity);
	self.window[12]:SetOpacity(settings.opacity);
	self.window[13]:SetOpacity(settings.opacity);
	self.window[14]:SetOpacity(settings.opacity);
	self.window[15]:SetOpacity(settings.opacity);
	self.window[16]:SetOpacity(settings.opacity);
	self.window[17]:SetOpacity(settings.opacity);

	-- SET WINDOW VISIBILITY
	self.window[1]:SetVisible(self.settings.ballads.active);
	--T1Ballads Level Check
	if (curlevel < self.skills["BalladofVigour"].Level) then
		self.window[1].bar[1]:SetVisible(false);
	end
	if (curlevel < self.skills["BalladofSteel"].Level) then
		self.window[1].bar[2]:SetVisible(false);
	end
	if (curlevel < self.skills["BalladofResonance"].Level) then
		self.window[1].bar[3]:SetVisible(false);
	end
	
	self.window[2]:SetVisible(self.settings.ballads.active);
	self.window[2].bar[1]:SetVisible(false);
	self.window[2].bar[2]:SetVisible(false);
	self.window[2].bar[3]:SetVisible(false);
	
	self.window[3]:SetVisible(self.settings.ballads.active);
	self.window[3].bar[1]:SetVisible(false);
	self.window[3].bar[2]:SetVisible(false);
	self.window[3].bar[3]:SetVisible(false);
	
	self.window[4]:SetVisible(self.settings.anthems.active);
	self.window[4].bar[1]:SetVisible(false);
	self.window[4].bar[2]:SetVisible(false);
	self.window[4].bar[3]:SetVisible(false);
	self.window[4].bar[4]:SetVisible(false);
	
	self.window[5]:SetVisible(self.settings.warspeech.active);
	self.window[5].bar[1]:SetVisible(curlevel >= self.skills["Warspeech"].Level);
	
	self.window[6]:SetVisible(self.settings.calls.active);
	self.window[6].bar[1]:SetVisible(false);
	self.window[6].bar[2]:SetVisible(false);
	self.window[6].bar[3]:SetVisible(false);
	
	self.window[7]:SetVisible(self.settings.damage.active);
	self.window[7].bar[1]:SetVisible(curlevel >= self.skills["EchoesofBattle"].Level);
	self.window[7].bar[2]:SetVisible(curlevel >= self.skills["PiercingCry"].Level);
	
	self.window[8]:SetVisible(self.settings.dethreat.active);
	
	self.window[9]:SetVisible(self.settings.melee.active);
	self.window[9].bar[1]:SetVisible(curlevel >= self.skills["NobleCause"].Level);
	if (curlevel >= self.skills["ImprovedHeraldsStrike"].Level) then
		self.window[9].bar[3]:SetVisible(self.settings.melee.active);
		self.window[9].bar[3]:SetZOrder(10);
		self.window[9].bar[2]:SetVisible(false);
		self.window[9].bar[2]:SetZOrder(0);
	elseif (curlevel >= self.skills["HeraldsStrike"].Level) then
		self.window[9].bar[2]:SetVisible(self.settings.melee.active);
		self.window[9].bar[2]:SetZOrder(10);
		self.window[9].bar[3]:SetVisible(false);
		self.window[9].bar[3]:SetZOrder(0);
	else
		self.window[9].bar[2]:SetVisible(false);
		self.window[9].bar[2]:SetZOrder(10);
		self.window[9].bar[3]:SetVisible(false);
		self.window[9].bar[3]:SetZOrder(0);
	end
	
	self.window[10]:SetVisible(self.settings.heals.active);
	self.window[10].bar[1]:SetVisible(curlevel >= self.skills["RaisetheSpirit"].Level);
	self.window[10].bar[2]:SetVisible(curlevel >= self.skills["BolsterCourage"].Level);
	self.window[10].bar[3]:SetVisible(curlevel >= self.skills["InspireFellows"].Level);
	self.window[10].bar[4]:SetVisible(curlevel >= self.skills["TriumphantSpirit"].Level);
	self.window[10].bar[5]:SetVisible(curlevel >= self.skills["ChordofSalvation"].Level);
	self.window[10].bar[6]:SetVisible(curlevel >= self.skills["SoliloquyofSpirit"].Level);
	
	self.window[11]:SetVisible(self.settings.tales.active);
	self.window[11].bar[1].slot[1]:SetMulti(self.settings.tales.current);
	if (self.settings.tales.master and curlevel >= self.skills["TaleofWardingandHeroism"].Level) then
		self.window[11].bar[1].slot[1]:ChangeTotal(6);
	elseif (curlevel >= self.skills["TaleofFrostandFlame"].Level) then
		self.window[11].bar[1].slot[1]:ChangeTotal(4);
	elseif (curlevel >= self.skills["TaleofWarding"].Level) then
		self.window[11].bar[1].slot[1]:ChangeTotal(3);
	elseif (curlevel >= self.skills["TaleofBattle"].Level) then
		self.window[11].bar[1].slot[1]:ChangeTotal(2);
	elseif (curlevel >= self.skills["TaleofHeroism"].Level) then
		self.window[11].bar[1].slot[1]:ChangeTotal(1);
	else
		self.window[11].bar[1].slot[1]:ChangeTotal(0);
		self.window[11].bar[1]:SetVisible(false);
	end
	
	self.window[12]:SetVisible(self.settings.utility.active);
	self.window[12].bar[1]:SetVisible(curlevel >= self.skills["SongofAid"].Level);
	self.window[12].bar[2]:SetVisible(curlevel >= self.skills["CalltotheFellowship"].Level);
	self.window[12].bar[3]:SetVisible(curlevel >= self.skills["GiftoftheHammerhand"].Level);
	self.window[12].bar[4]:SetVisible(curlevel >= self.skills["CalltoGreatness"].Level);
	self.window[12].bar[5]:SetVisible(curlevel >= self.skills["SongoftheHopefulHeart"].Level and self.settings.utility.songhopeful);
	
	self.window[13]:SetVisible(self.settings.rez.active);
	self.window[13].bar[1]:SetVisible(curlevel >= self.skills["SongofRestoration"].Level);
	self.window[13].bar[2]:SetVisible(curlevel >= self.skills["EnliveningGrace"].Level);
	self.window[13].bar[3]:SetVisible(curlevel >= self.skills["ChorusofRestoration"].Level);
	self.window[13].bar[4]:SetVisible(curlevel >= self.skills["Rally"].Level and self.settings.rez.rally);
	
	self.window[14]:SetVisible(self.settings.silence.active);
	self.window[14].bar[1]:SetVisible(false);
	self.window[14].bar[2]:SetVisible(false);
	
	self.window[15]:SetVisible(self.settings.crowdcontrol.active);
	self.window[15].bar[1]:SetVisible(curlevel >= self.skills["CryoftheValar"].Level);
	self.window[15].bar[2]:SetVisible(curlevel >= self.skills["SongoftheDead"].Level);
	self.window[15].bar[3]:SetVisible(curlevel >= self.skills["SongofDistraction"].Level);
		
	self.window[16]:SetVisible(self.settings.fear.active);
	self.window[16].bar[1]:SetVisible(curlevel >= self.skills["CureFear"].Level);
	self.window[16].bar[2]:SetVisible(curlevel >= self.skills["FellowshipsHeart"].Level and self.settings.fear.fellowship);
	
	self.window[17]:SetVisible(self.settings.shield.active);
	if (curlevel >= self.skills["LyricoftheHammerhand"].Level) then
		self.window[17].bar[2]:SetVisible(true);
		self.window[17].bar[2]:SetZOrder(10);
		self.window[17].bar[1]:SetVisible(false);
		self.window[17].bar[1]:SetZOrder(0);
	elseif (curlevel >= self.skills["LayoftheHammerhand"].Level) then
		self.window[17].bar[2]:SetVisible(false);
		self.window[17].bar[2]:SetZOrder(0);
		self.window[17].bar[1]:SetVisible(true);
		self.window[17].bar[1]:SetZOrder(10);
	else
		self.window[17].bar[2]:SetVisible(false);
		self.window[17].bar[2]:SetZOrder(0);
		self.window[17].bar[1]:SetVisible(false);
		self.window[17].bar[1]:SetZOrder(0);
	end
	
	if (self.player:IsInCombat() == false) then
		self.window[8].bar[1]:SetVisible(false);
		self.window[8].bar[2]:SetVisible(false);
	elseif (self.player:IsInCombat() == true ) then
		self.window[8].bar[1]:SetVisible(self.settings.dethreat.active and curlevel >= self.skills["SongofSoothing"].Level);
		self.window[8].bar[2]:SetVisible(self.settings.dethreat.active and curlevel >= self.skills["StillasDeath"].Level);
	end
	
	Turbine.Shell.WriteLine("Kragenbars: Minstrel Bars refresh completed successfully.");

end