import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "Turbine.Utils";
import "KragenPlugs.KragenBars";

RuneBars = class( );

function RuneBars:Constructor()

 	-- inialize the setupWindow
	self.setup = SetupWindow();
	self.RuneSetup = RuneSetup();
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		self.player = Turbine.Gameplay.LocalPlayer.GetInstance();
	else
		self.player = Turbine.Gameplay.LocalPlayer();
	end
	local curlevel = self.player:GetLevel();

	-- class settings arent saved then load the default settings
	if (not settings.class) then
	    settings.class = "Runekeeper";
	    self:DefaultSettings();
	    self:ShowSetup();
	else
		self.settings = settings.classinfo;
		if (settings.vers ~= mainvars.vers) then
			self:UpdateSettings();
		end
	end

	-- Build skills and level tables
	
	self.skills = { };
	self.skills["ScribesSpark"]=			{["Level"]=1,["Hex"]="0x7000EEAD"};
	self.skills["FieryRidicule"]=			{["Level"]=1,["Hex"]="0x7000E96B"};
	self.skills["PreludetoHope"]=			{["Level"]=1,["Hex"]="0x7000EEAA"};
	self.skills["ShockingWords"]=			{["Level"]=2,["Hex"]="0x7000EEAE"};
	self.skills["CeaselessArgument"]=		{["Level"]=4,["Hex"]="0x7000EEAC"};
	self.skills["RuneofRestoration"]=		{["Level"]=4,["Hex"]="0x7000EEA5"};
	self.skills["ChillingRhetoric"]=		{["Level"]=6,["Hex"]="0x7000EE02"};
	self.skills["FalltoStorm"]=				{["Level"]=8,["Hex"]="0x7000F340"};
	self.skills["ShockingTouch"]=			{["Level"]=8,["Hex"]="0x7000F488"};
	self.skills["ArmourofStorm"]=			{["Level"]=10,["Hex"]="0x7000F33A"};
	self.skills["MendingVerse"]=			{["Level"]=10,["Hex"]="0x7000EEA8"};
	self.skills["WritofCold"]=				{["Level"]=12,["Hex"]="0x7000EE00"};
	self.skills["WritofHealth"]=			{["Level"]=12,["Hex"]="0x7000EEA9"};
	self.skills["RousingWords"]=			{["Level"]=14,["Hex"]="0x7000EEA4"};
	self.skills["Selfmotivation"]=			{["Level"]=14,["Hex"]="0x7000E037"};
	self.skills["EssenceofStorm"]=			{["Level"]=16,["Hex"]="0x7000EEAB"};
	self.skills["EpicfortheAges"]=			{["Level"]=18,["Hex"]="0x7000EEA6"};
	self.skills["EpicConclusion"]=			{["Level"]=20,["Hex"]="0x7000EEAF"};
	self.skills["NothingTrulyEnds"]=		{["Level"]=20,["Hex"]="0x7000EDA1"};
	self.skills["WritofFire"]=				{["Level"]=22,["Hex"]="0x7000EFF0"};
	self.skills["EssenceofWinter"]=			{["Level"]=24,["Hex"]="0x7000EE01"};
	self.skills["CalmingVerse"]=			{["Level"]=26,["Hex"]="0x70018275"};
	self.skills["WordofExaltation"]=		{["Level"]=28,["Hex"]="0x7000EEA7"};
	self.skills["ScathingMockery"]=			{["Level"]=28,["Hex"]="0x7000E969"};
	self.skills["AbruptWords"]=				{["Level"]=30,["Hex"]="0x70017EEB"};
	self.skills["DistractingWinds"]=		{["Level"]=30,["Hex"]="0x7000EC5D"};
	self.skills["FrozenEpilogue"]=			{["Level"]=32,["Hex"]="0x7000EE03"};
	self.skills["WeaponofStorm"]=			{["Level"]=34,["Hex"]="0x7000F33D"};
	self.skills["EssenceofFlame"]=			{["Level"]=36,["Hex"]="0x7000EFEF"};
	self.skills["FlurryofWords"]=			{["Level"]=38,["Hex"]="0x7000EDFF"};
	self.skills["FalltoOurWrath"]=			{["Level"]=39,["Hex"]="0x700180F3"};
	self.skills["SteadyHands"]=				{["Level"]=39,["Hex"]="0x700180F2"};
	self.skills["SmoulderingWrath"]=		{["Level"]=40,["Hex"]="0x7000E96D"};
	self.skills["TheBladeWillNotWound"]=	{["Level"]=40,["Hex"]="0x7000F2A1"};
	self.skills["EssayofExaltation"]=		{["Level"]=42,["Hex"]="0x70018636"};
	self.skills["TheFangWillNotPoison"]=	{["Level"]=44,["Hex"]="0x7000F2A0"};
	self.skills["ThatWhichDoesNotKillUs"]=	{["Level"]=45,["Hex"]="0x700180F4"};
	self.skills["DoNotFalltoStorm"]=		{["Level"]=46,["Hex"]="0x7000F343"};
	self.skills["OurFatesEntwined"]=		{["Level"]=48,["Hex"]="0x7000EDA7"};
	self.skills["DoNotFallThisDay"]=		{["Level"]=50,["Hex"]="0x7000F25D"};
	self.skills["FinalWords"]=				{["Level"]=52,["Hex"]="0x70018775"};
	self.skills["AllFatesEntwined"]=		{["Level"]=54,["Hex"]="0x70018776"};
	self.skills["VividImagery"]=			{["Level"]=56,["Hex"]="0x700180F9"};
	self.skills["GloriousForeshadowing"]=	{["Level"]=58,["Hex"]="0x700180F7"};
	self.skills["DistractingFlame"]=		{["Level"]=60,["Hex"]="0x700180F5"};
	self.skills["ShallNotFallThisDay"]=		{["Level"]=62,["Hex"]="0x7001F4A0"};
	self.skills["ArmamentsofStorm"]=		{["Level"]=64,["Hex"]="0x70020DFC"};
	
   
    self.window = { };

    -- Center: Control
    self.window[1] = Window("Center: Control", 2, 1, 0, 0, self.settings.centercontrol);

		self.window[1]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[1].bar[1]:AddQuickSlot(1, 1, 1, self.skills["ShockingTouch"].Hex);
		
		self.window[1]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[1].bar[2]:AddQuickSlot(1, 1, 1, self.skills["AbruptWords"].Hex);
		
		self.window[1]:AddBar(3, 1, 1, 1, 0, true, false);
		self.window[1].bar[3]:AddQuickSlot(1, 1, 1, self.skills["FinalWords"].Hex);
		
	-- Center: Buffs
    self.window[2] = Window("Center: Buffs", 2, 1, 2, 0, self.settings.centerbuffs);

		self.window[2]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[2].bar[1]:AddQuickSlot(1, 1, 1, self.skills["ArmourofStorm"].Hex);
		
		self.window[2]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[2].bar[2]:AddQuickSlot(1, 1, 1, self.skills["WeaponofStorm"].Hex);
		
		self.window[2]:AddBar(3, 1, 1, 1, 0, true, false);
		self.window[2].bar[3]:AddQuickSlot(1, 1, 1, self.skills["ArmamentsofStorm"].Hex);

	-- Center: Dethreat
    self.window[3] = Window("Center: Dethreat", 2, 1, 4, 0, self.settings.centerdethreat);

		self.window[3]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[3].bar[1]:AddQuickSlot(1, 1, 1, self.skills["CalmingVerse"].Hex);
		
		self.window[3]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[3].bar[2]:AddQuickSlot(1, 1, 1, self.skills["DistractingWinds"].Hex);
		
	-- Center: Foretelling
    self.window[4] = Window("Center: Foretelling", 4, 1, 0, 1, self.settings.centerforetell);

		self.window[4]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[4].bar[1]:AddQuickSlot(1, 1, 1, self.skills["TheBladeWillNotWound"].Hex);
		
		self.window[4]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[4].bar[2]:AddQuickSlot(1, 1, 1, self.skills["TheFangWillNotPoison"].Hex);
		
		self.window[4]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[4].bar[3]:AddQuickSlot(1, 1, 1, self.skills["DoNotFalltoStorm"].Hex);
		
		self.window[4]:AddBar(4, 1, 1, 3, 0, true, false);
		self.window[4].bar[4]:AddQuickSlot(1, 1, 1, self.skills["DoNotFallThisDay"].Hex);
		
		self.window[4]:AddBar(5, 1, 1, 3, 0, true, false);
		self.window[4].bar[5]:AddQuickSlot(1, 1, 1, self.skills["ShallNotFallThisDay"].Hex);
		
	-- Center: Self Control
    self.window[5] = Window("Center: Self Control", 2, 1, 4, 1, self.settings.centerself);

		self.window[5]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[5].bar[1]:AddQuickSlot(1, 1, 1, self.skills["Selfmotivation"].Hex);
		
		self.window[5]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[5].bar[2]:AddQuickSlot(1, 1, 1, self.skills["SteadyHands"].Hex);
		
	-- Center: Damage Vision
    self.window[6] = Window("Center: Damage Vision", 2, 1, 6, 1, self.settings.centervision);

		self.window[6]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[6].bar[1]:AddQuickSlot(1, 1, 1, self.skills["FalltoStorm"].Hex);
		
		self.window[6]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[6].bar[2]:AddQuickSlot(1, 1, 1, self.skills["FalltoOurWrath"].Hex);
		
	-- Battle: Storm
    self.window[7] = Window("Battle: Storm", 6, 1, 0, 2, self.settings.battlestorm);

		self.window[7]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[7].bar[1]:AddQuickSlot(1, 1, 1, self.skills["ScribesSpark"].Hex);
		
		self.window[7]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[7].bar[2]:AddQuickSlot(1, 1, 1, self.skills["CeaselessArgument"].Hex);
		
		self.window[7]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[7].bar[3]:AddQuickSlot(1, 1, 1, self.skills["ShockingWords"].Hex);
		
		self.window[7]:AddBar(4, 1, 1, 3, 0, true, false);
		self.window[7].bar[4]:AddQuickSlot(1, 1, 1, self.skills["EssenceofStorm"].Hex);
		
		self.window[7]:AddBar(5, 1, 1, 4, 0, true, false);
		self.window[7].bar[5]:AddQuickSlot(1, 1, 1, self.skills["EpicConclusion"].Hex);
		
		self.window[7]:AddBar(6, 1, 1, 5, 0, true, false);
		self.window[7].bar[6]:AddQuickSlot(1, 1, 1, self.skills["VividImagery"].Hex);
		
	-- Battle: Frost
    self.window[8] = Window("Battle: Frost", 5, 1, 0, 3, self.settings.battlefrost);

		self.window[8]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[8].bar[1]:AddQuickSlot(1, 1, 1, self.skills["ChillingRhetoric"].Hex);
		
		self.window[8]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[8].bar[2]:AddQuickSlot(1, 1, 1, self.skills["WritofCold"].Hex);
		
		self.window[8]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[8].bar[3]:AddQuickSlot(1, 1, 1, self.skills["FlurryofWords"].Hex);
		
		self.window[8]:AddBar(4, 1, 1, 3, 0, true, false);
		self.window[8].bar[4]:AddQuickSlot(1, 1, 1, self.skills["EssenceofWinter"].Hex);
		
		self.window[8]:AddBar(5, 1, 1, 4, 0, true, false);
		self.window[8].bar[5]:AddQuickSlot(1, 1, 1, self.skills["FrozenEpilogue"].Hex);
		
	-- Battle: Flame
    self.window[9] = Window("Battle: Frost", 6, 1, 0, 4, self.settings.battleflame);

		self.window[9]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[9].bar[1]:AddQuickSlot(1, 1, 1, self.skills["FieryRidicule"].Hex);
		
		self.window[9]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[9].bar[2]:AddQuickSlot(1, 1, 1, self.skills["WritofFire"].Hex);
		
		self.window[9]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[9].bar[3]:AddQuickSlot(1, 1, 1, self.skills["DistractingFlame"].Hex);
		
		self.window[9]:AddBar(4, 1, 1, 3, 0, true, false);
		self.window[9].bar[4]:AddQuickSlot(1, 1, 1, self.skills["EssenceofFlame"].Hex);
		
		self.window[9]:AddBar(5, 1, 1, 4, 0, true, false);
		self.window[9].bar[5]:AddQuickSlot(1, 1, 1, self.skills["ScathingMockery"].Hex);
		
		self.window[9]:AddBar(6, 1, 1, 5, 0, true, false);
		self.window[9].bar[6]:AddQuickSlot(1, 1, 1, self.skills["SmoulderingWrath"].Hex);
		
	-- Healing
    self.window[10] = Window("Healing", 8, 1, 0, 5, self.settings.healing);

		self.window[10]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[10].bar[1]:AddQuickSlot(1, 1, 1, self.skills["RuneofRestoration"].Hex);
		
		self.window[10]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[10].bar[2]:AddQuickSlot(1, 1, 1, self.skills["PreludetoHope"].Hex);
		
		self.window[10]:AddBar(3, 1, 1, 2, 0, true, false);
		self.window[10].bar[3]:AddQuickSlot(1, 1, 1, self.skills["MendingVerse"].Hex);
		
		self.window[10]:AddBar(4, 1, 1, 3, 0, true, false);
		self.window[10].bar[4]:AddQuickSlot(1, 1, 1, self.skills["WritofHealth"].Hex);
		
		self.window[10]:AddBar(5, 1, 1, 4, 0, true, false);
		self.window[10].bar[5]:AddQuickSlot(1, 1, 1, self.skills["EpicfortheAges"].Hex);
		
		self.window[10]:AddBar(6, 1, 1, 5, 0, true, false);
		self.window[10].bar[6]:AddQuickSlot(1, 1, 1, self.skills["WordofExaltation"].Hex);
		
		self.window[10]:AddBar(7, 1, 1, 6, 0, true, false);
		self.window[10].bar[7]:AddQuickSlot(1, 1, 1, self.skills["RousingWords"].Hex);
		
		self.window[10]:AddBar(8, 1, 1, 7, 0, true, false);
		self.window[10].bar[8]:AddQuickSlot(1, 1, 1, self.skills["EssayofExaltation"].Hex);
		
	-- Heal: Foretelling
    self.window[11] = Window("Heal: Foretelling", 4, 1, 0, 6, self.settings.healforetell);

		self.window[11]:AddBar(1, 1, 1, 0, 0, true, false);
		self.window[11].bar[1]:AddQuickSlot(1, 1, 1, self.skills["NothingTrulyEnds"].Hex);
		
		self.window[11]:AddBar(2, 1, 1, 1, 0, true, false);
		self.window[11].bar[2]:AddQuickSlot(1, 1, 1, self.skills["OurFatesEntwined"].Hex);
		
		self.window[11]:AddBar(3, 1, 1, 1, 0, true, false);
		self.window[11].bar[3]:AddQuickSlot(1, 1, 1, self.skills["AllFatesEntwined"].Hex);
		
		self.window[11]:AddBar(4, 1, 1, 2, 0, true, false);
		self.window[11].bar[4]:AddQuickSlot(1, 1, 1, self.skills["GloriousForeshadowing"].Hex);
		
		self.window[11]:AddBar(5, 1, 1, 3, 0, true, false);
		self.window[11].bar[5]:AddQuickSlot(1, 1, 1, self.skills["ThatWhichDoesNotKillUs"].Hex);
		

	self:Refresh();
	
	-- Hook into the player to receive updates about player morale and
	-- power.
	local effects = self.player:GetEffects();

	effects.EffectAdded = function( sender, args )
		self:AddEffect( args.Index );
	end

	effects.EffectRemoved = function( sender, args )
		self:RemoveEffect( args.Effect );
	end
	
end


function RuneBars:AddEffect( effectIndex )
	local curlevel = self.player:GetLevel();
	local addedeffect = self.player:GetEffects():Get( effectIndex );

end


function RuneBars:RemoveEffect( effect )
	local curlevel = self.player:GetLevel();

end


function RuneBars:DefaultSettings()
	self.settings = { };

	self.settings.centercontrol = { };
	self.settings.centercontrol.active = true;
	self.settings.centercontrol.x = 0;
	self.settings.centercontrol.y = 0;

	self.settings.centerbuffs = { };
	self.settings.centerbuffs.active = true;
	self.settings.centerbuffs.x = 0;
	self.settings.centerbuffs.y = 0;

	self.settings.centerdethreat = { };
	self.settings.centerdethreat.active = true;
	self.settings.centerdethreat.x = 0;
	self.settings.centerdethreat.y = 0;

	self.settings.centerforetell = { };
	self.settings.centerforetell.active = true;
	self.settings.centerforetell.x = 0;
	self.settings.centerforetell.y = 0;

	self.settings.centerself = { };
	self.settings.centerself.active = true;
	self.settings.centerself.x = 0;
	self.settings.centerself.y = 0;
	self.settings.centerself.steady = false;

	self.settings.centervision = { };
	self.settings.centervision.active = true;
	self.settings.centervision.x = 0;
	self.settings.centervision.y = 0;
	self.settings.centervision.wrath = false;

	self.settings.battlestorm = { };
	self.settings.battlestorm.active = true;
	self.settings.battlestorm.x = 0;
	self.settings.battlestorm.y = 0;

	self.settings.battlefrost = { };
	self.settings.battlefrost.active = true;
	self.settings.battlefrost.x = 0;
	self.settings.battlefrost.y = 0;

	self.settings.battleflame = { };
	self.settings.battleflame.active = true;
	self.settings.battleflame.x = 0;
	self.settings.battleflame.y = 0;

	self.settings.healing = { };
	self.settings.healing.active = true;
	self.settings.healing.x = 0;
	self.settings.healing.y = 0;

	self.settings.healforetell = { };
	self.settings.healforetell.active = true;
	self.settings.healforetell.x = 0;
	self.settings.healforetell.y = 0;
	self.settings.healforetell.kill = false;

end


function RuneBars:UpdateSettings()
	settings.vers = mainvars.vers;
	
end


function RuneBars:SaveSettings()
	self.settings.centercontrol.x, self.settings.centercontrol.y = self.window[1]:GetPosition();
	self.settings.centerbuffs.x, self.settings.centerbuffs.y = self.window[2]:GetPosition();
	self.settings.centerdethreat.x, self.settings.centerdethreat.y = self.window[3]:GetPosition();
	self.settings.centerforetell.x, self.settings.centerforetell.y = self.window[4]:GetPosition();
	self.settings.centerself.x, self.settings.centerself.y = self.window[5]:GetPosition();
	self.settings.centervision.x, self.settings.centervision.y = self.window[6]:GetPosition();
	self.settings.battlestorm.x, self.settings.battlestorm.y = self.window[7]:GetPosition();
	self.settings.battlefrost.x, self.settings.battlefrost.y = self.window[8]:GetPosition();
	self.settings.battleflame.x, self.settings.battleflame.y = self.window[9]:GetPosition();
	self.settings.healing.x, self.settings.healing.y = self.window[10]:GetPosition();
	self.settings.healforetell.x, self.settings.healforetell.y = self.window[11]:GetPosition();

	Turbine.Shell.WriteLine("Kragenbars: Runekeeper Bars settings saved successfully.");

	settings.classinfo = self.settings;
	SaveSettings();
	
end


function RuneBars:ShowSetup()
	self.setup:SetVisible(true);
	self.setup.slider1:SetValue(settings.opacity);
	
	self.setup.checkbox1:SetVisible(false);
	self.setup.checkbox2:SetVisible(false);
	self.setup.checkbox3:SetVisible(false);
  	self.setup.checkbox4:SetVisible(false);
   	self.setup.checkbox5:SetVisible(false);
  	self.setup.checkbox6:SetVisible(false);
  	self.setup.checkbox7:SetVisible(false);
  	self.setup.checkbox8:SetVisible(false);
    self.setup.checkbox9:SetVisible(false);
    self.setup.checkbox10:SetVisible(false);
    self.setup.checkbox11:SetVisible(false);
    self.setup.psTitle:SetVisible( false );
    self.setup.ssTitle:SetVisible( false );
	self.setup:SetText("KB: Runekeeper");

	self.RuneSetup:SetVisible(true);
	self.RuneSetup.checkbox1:SetText("Center: Control");
  	self.RuneSetup.checkbox1:SetChecked( self.settings.centercontrol.active );
	self.RuneSetup.checkbox2:SetText("Center: Buffs");
  	self.RuneSetup.checkbox2:SetChecked( self.settings.centerbuffs.active );
	self.RuneSetup.checkbox3:SetText("Center: Dethreat");
  	self.RuneSetup.checkbox3:SetChecked( self.settings.centerdethreat.active );
	self.RuneSetup.checkbox4:SetText("Center: Foretell");
  	self.RuneSetup.checkbox4:SetChecked( self.settings.centerforetell.active );
	self.RuneSetup.checkbox5:SetText("Center: Self");
  	self.RuneSetup.checkbox5:SetChecked( self.settings.centerself.active );
	self.RuneSetup.checkbox6:SetText("Center: Visions");
  	self.RuneSetup.checkbox6:SetChecked( self.settings.centervision.active );
	self.RuneSetup.checkbox7:SetText("Battle: Storm");
  	self.RuneSetup.checkbox7:SetChecked( self.settings.battlestorm.active );
	self.RuneSetup.checkbox8:SetText("Battle: Frost");
  	self.RuneSetup.checkbox8:SetChecked( self.settings.battlefrost.active );
	self.RuneSetup.checkbox9:SetText("Battle: Flame");
  	self.RuneSetup.checkbox9:SetChecked( self.settings.battleflame.active );
	self.RuneSetup.checkbox10:SetText("Healing");
  	self.RuneSetup.checkbox10:SetChecked( self.settings.healing.active );
	self.RuneSetup.checkbox11:SetText("Heal: Foretellings");
  	self.RuneSetup.checkbox11:SetChecked( self.settings.healforetell.active );
	self.RuneSetup.checkbox12:SetText("Steady Hands");
  	self.RuneSetup.checkbox12:SetChecked( self.settings.centerself.steady );
	self.RuneSetup.checkbox13:SetText("Fall to Our Wrath");
  	self.RuneSetup.checkbox13:SetChecked( self.settings.centervision.wrath );
	self.RuneSetup.checkbox14:SetText("That Which Does Not Kill Us");
  	self.RuneSetup.checkbox14:SetChecked( self.settings.healforetell.kill );

end


function RuneBars:SetupClosing()
    self.settings.centercontrol.active = self.RuneSetup.checkbox1:GetChecked();
    self.settings.centerbuffs.active = self.RuneSetup.checkbox2:GetChecked();
    self.settings.centerdethreat.active = self.RuneSetup.checkbox3:GetChecked();
    self.settings.centerforetell.active = self.RuneSetup.checkbox4:GetChecked();
    self.settings.centerself.active = self.RuneSetup.checkbox5:GetChecked();
    self.settings.centervision.active = self.RuneSetup.checkbox6:GetChecked();
    self.settings.battlestorm.active = self.RuneSetup.checkbox7:GetChecked();
    self.settings.battlefrost.active = self.RuneSetup.checkbox8:GetChecked();
    self.settings.battleflame.active = self.RuneSetup.checkbox9:GetChecked();
    self.settings.healing.active = self.RuneSetup.checkbox10:GetChecked();
    self.settings.healforetell.active = self.RuneSetup.checkbox11:GetChecked();
    self.settings.centerself.steady = self.RuneSetup.checkbox12:GetChecked();
    self.settings.centervision.wrath = self.RuneSetup.checkbox13:GetChecked();
    self.settings.healforetell.kill = self.RuneSetup.checkbox14:GetChecked();
	self.RuneSetup:SetVisible(false);
	
	self:SaveSettings();
	self:Refresh();
	
end
	
	
function RuneBars:Refresh()
	local curlevel = self.player:GetLevel();

		-- SET WINDOW OPACITY
	self.window[1]:SetOpacity(settings.opacity);
	self.window[2]:SetOpacity(settings.opacity);
	self.window[3]:SetOpacity(settings.opacity);
	self.window[4]:SetOpacity(settings.opacity);
	self.window[5]:SetOpacity(settings.opacity);
	self.window[6]:SetOpacity(settings.opacity);
	self.window[7]:SetOpacity(settings.opacity);
	self.window[8]:SetOpacity(settings.opacity);
	self.window[9]:SetOpacity(settings.opacity);
	self.window[10]:SetOpacity(settings.opacity);
	self.window[11]:SetOpacity(settings.opacity);

	-- SET WINDOW VISIBILITY
	self.window[1]:SetVisible(self.settings.centercontrol.active);
	if (curlevel < self.skills["ShockingTouch"].Level) then
		self.window[1].bar[1]:SetVisible(false);
	end
	if (curlevel >= self.skills["FinalWords"].Level) then
		self.window[1].bar[3]:SetVisible(self.settings.centercontrol.active);
		self.window[1].bar[3]:SetZOrder(10);
		self.window[1].bar[2]:SetVisible(false);
		self.window[1].bar[2]:SetZOrder(0);
	elseif (curlevel >= self.skills["AbruptWords"].Level) then
		self.window[1].bar[2]:SetVisible(self.settings.centercontrol.active);
		self.window[1].bar[2]:SetZOrder(10);
		self.window[1].bar[3]:SetVisible(false);
		self.window[1].bar[3]:SetZOrder(0);
	else
		self.window[1].bar[2]:SetVisible(false);
		self.window[1].bar[2]:SetZOrder(10);
		self.window[1].bar[3]:SetVisible(false);
		self.window[1].bar[3]:SetZOrder(0);
	end

	self.window[2]:SetVisible(self.settings.centerbuffs.active);
	if (curlevel < self.skills["ArmourofStorm"].Level) then
		self.window[2].bar[1]:SetVisible(false);
	end
	if (curlevel >= self.skills["ArmamentsofStorm"].Level) then
		self.window[2].bar[3]:SetVisible(self.settings.centerbuffs.active);
		self.window[2].bar[3]:SetZOrder(10);
		self.window[2].bar[2]:SetVisible(false);
		self.window[2].bar[2]:SetZOrder(0);
	elseif (curlevel >= self.skills["WeaponofStorm"].Level) then
		self.window[2].bar[2]:SetVisible(self.settings.centerbuffs.active);
		self.window[2].bar[2]:SetZOrder(10);
		self.window[2].bar[3]:SetVisible(false);
		self.window[2].bar[3]:SetZOrder(0);
	else
		self.window[2].bar[2]:SetVisible(false);
		self.window[2].bar[2]:SetZOrder(10);
		self.window[2].bar[3]:SetVisible(false);
		self.window[2].bar[3]:SetZOrder(0);
	end

	self.window[3]:SetVisible(self.settings.centerdethreat.active);
	if (curlevel < self.skills["CalmingVerse"].Level) then
		self.window[3].bar[1]:SetVisible(false);
	end
	if (curlevel < self.skills["DistractingWinds"].Level) then
		self.window[3].bar[2]:SetVisible(false);
	end
	
	self.window[4]:SetVisible(self.settings.centerforetell.active);
	if (curlevel < self.skills["TheBladeWillNotWound"].Level) then
		self.window[4].bar[1]:SetVisible(false);
	end
	if (curlevel < self.skills["TheFangWillNotPoison"].Level) then
		self.window[4].bar[2]:SetVisible(false);
	end
	if (curlevel < self.skills["DoNotFalltoStorm"].Level) then
		self.window[4].bar[3]:SetVisible(false);
	end
	if (curlevel >= self.skills["ShallNotFallThisDay"].Level) then
		self.window[4].bar[5]:SetVisible(self.settings.centerforetell.active);
		self.window[4].bar[5]:SetZOrder(10);
		self.window[4].bar[4]:SetVisible(false);
		self.window[4].bar[4]:SetZOrder(0);
	elseif (curlevel >= self.skills["DoNotFallThisDay"].Level) then
		self.window[4].bar[4]:SetVisible(self.settings.centerforetell.active);
		self.window[4].bar[4]:SetZOrder(10);
		self.window[4].bar[5]:SetVisible(false);
		self.window[4].bar[5]:SetZOrder(0);
	else
		self.window[4].bar[4]:SetVisible(false);
		self.window[4].bar[4]:SetZOrder(10);
		self.window[4].bar[5]:SetVisible(false);
		self.window[4].bar[5]:SetZOrder(0);
	end

	self.window[5]:SetVisible(self.settings.centerself.active);
	if (curlevel < self.skills["Selfmotivation"].Level) then
		self.window[5].bar[1]:SetVisible(false);
	end
	if (curlevel < self.skills["SteadyHands"].Level) then
		self.window[5].bar[2]:SetVisible(false);
	else
		self.window[5].bar[2]:SetVisible(self.settings.centerself.steady);
	end
	
	self.window[6]:SetVisible(self.settings.centervision.active);
	if (curlevel < self.skills["FalltoStorm"].Level) then
		self.window[6].bar[1]:SetVisible(false);
	end
	if (curlevel < self.skills["FalltoOurWrath"].Level) then
		self.window[6].bar[2]:SetVisible(false);
	else
		self.window[6].bar[2]:SetVisible(self.settings.centervision.wrath);
	end
	
	self.window[7]:SetVisible(self.settings.battlestorm.active);
	if (curlevel < self.skills["ScribesSpark"].Level) then
		self.window[7].bar[1]:SetVisible(false);
	end
	if (curlevel < self.skills["CeaselessArgument"].Level) then
		self.window[7].bar[2]:SetVisible(false);
	end
	if (curlevel < self.skills["ShockingWords"].Level) then
		self.window[7].bar[3]:SetVisible(false);
	end
	if (curlevel < self.skills["EssenceofStorm"].Level) then
		self.window[7].bar[4]:SetVisible(false);
	end
	if (curlevel < self.skills["EpicConclusion"].Level) then
		self.window[7].bar[5]:SetVisible(false);
	end
	if (curlevel < self.skills["VividImagery"].Level) then
		self.window[7].bar[6]:SetVisible(false);
	end
	
	self.window[8]:SetVisible(self.settings.battlefrost.active);
	if (curlevel < self.skills["ChillingRhetoric"].Level) then
		self.window[8].bar[1]:SetVisible(false);
	end
	if (curlevel < self.skills["WritofCold"].Level) then
		self.window[8].bar[2]:SetVisible(false);
	end
	if (curlevel < self.skills["EssenceofWinter"].Level) then
		self.window[8].bar[3]:SetVisible(false);
	end
	if (curlevel < self.skills["FlurryofWords"].Level) then
		self.window[8].bar[4]:SetVisible(false);
	end
	if (curlevel < self.skills["FrozenEpilogue"].Level) then
		self.window[8].bar[5]:SetVisible(false);
	end
	
	self.window[9]:SetVisible(self.settings.battleflame.active);
	if (curlevel < self.skills["FieryRidicule"].Level) then
		self.window[9].bar[1]:SetVisible(false);
	end
	if (curlevel < self.skills["WritofFire"].Level) then
		self.window[9].bar[2]:SetVisible(false);
	end
	if (curlevel < self.skills["DistractingFlame"].Level) then
		self.window[9].bar[3]:SetVisible(false);
	end
	if (curlevel < self.skills["EssenceofFlame"].Level) then
		self.window[9].bar[4]:SetVisible(false);
	end
	if (curlevel < self.skills["ScathingMockery"].Level) then
		self.window[9].bar[5]:SetVisible(false);
	end
	if (curlevel < self.skills["SmoulderingWrath"].Level) then
		self.window[9].bar[6]:SetVisible(false);
	end
	
	self.window[10]:SetVisible(self.settings.healing.active);
	if (curlevel < self.skills["RuneofRestoration"].Level) then
		self.window[10].bar[1]:SetVisible(false);
	end
	if (curlevel < self.skills["PreludetoHope"].Level) then
		self.window[10].bar[2]:SetVisible(false);
	end
	if (curlevel < self.skills["MendingVerse"].Level) then
		self.window[10].bar[3]:SetVisible(false);
	end
	if (curlevel < self.skills["WritofHealth"].Level) then
		self.window[10].bar[4]:SetVisible(false);
	end
	if (curlevel < self.skills["EpicfortheAges"].Level) then
		self.window[10].bar[5]:SetVisible(false);
	end
	if (curlevel < self.skills["WordofExaltation"].Level) then
		self.window[10].bar[6]:SetVisible(false);
	end
	if (curlevel < self.skills["RousingWords"].Level) then
		self.window[10].bar[7]:SetVisible(false);
	end
	if (curlevel < self.skills["EssayofExaltation"].Level) then
		self.window[10].bar[8]:SetVisible(false);
	end
	
	self.window[11]:SetVisible(self.settings.healforetell.active);
	if (curlevel < self.skills["NothingTrulyEnds"].Level) then
		self.window[11].bar[1]:SetVisible(false);
	end
	if (curlevel >= self.skills["AllFatesEntwined"].Level) then
		self.window[11].bar[3]:SetVisible(self.settings.healforetell.active);
		self.window[11].bar[3]:SetZOrder(10);
		self.window[11].bar[2]:SetVisible(false);
		self.window[11].bar[2]:SetZOrder(0);
	elseif (curlevel >= self.skills["OurFatesEntwined"].Level) then
		self.window[11].bar[2]:SetVisible(self.settings.healforetell.active);
		self.window[11].bar[2]:SetZOrder(10);
		self.window[11].bar[3]:SetVisible(false);
		self.window[11].bar[3]:SetZOrder(0);
	else
		self.window[11].bar[2]:SetVisible(false);
		self.window[11].bar[2]:SetZOrder(10);
		self.window[11].bar[3]:SetVisible(false);
		self.window[11].bar[3]:SetZOrder(0);
	end
	if (curlevel < self.skills["GloriousForeshadowing"].Level) then
		self.window[11].bar[4]:SetVisible(false);
	end
	if (curlevel < self.skills["ThatWhichDoesNotKillUs"].Level) then
		self.window[11].bar[5]:SetVisible(false);
	else
		self.window[11].bar[5]:SetVisible(self.settings.healforetell.kill);
	end
		
	Turbine.Shell.WriteLine("Kragenbars: Runekeeper Bars refresh completed successfully.");

end